/*
 *  anet.h
 *  Anet
 *
 *  Created by Nicolas Sicard on Tue Sep 24 2002.
 *  Copyright (c) 2002 IEF. All rights reserved.
 *
 */

#ifndef _ANET_H_
#define _ANET_H_

#include "core.h"
#include "elmtwise.h"
#include "boolwise.h"
#include "reduce.h"
#include "local.h"
#include "step.h"
#include "mgraph.h"
#include "rgraph.h"
#include "direct.h"
#include "assoc.h"
#include "files.h"

#define ANET_TIMING

/* macro definition for performance timing */
#ifdef ANET_TIMING

#include <stdio.h>
#include <sys/types.h>
#include <sys/times.h>
#include <sys/time.h>

#define NEW_TIME(t) \
struct timezone t ## _tz; \
struct timeval t ## _tv, t ## _tstart;

#define START_TIME(t) \
gettimeofday(& t ## _tstart, & t ## _tz);

#define END_TIME(t) \
gettimeofday(& t ## _tv, & t ## _tz);

#define PRINT_TIME(t,msg) \
printf("%s = %f ms\n", msg, (float)( t ## _tv.tv_usec - t ## _tstart.tv_usec \
                                     + 1000000*( t ## _tv.tv_sec - t ## _tstart.tv_sec)) / 1000.0)

#define GET_TIME(t) ((float)( t ## _tv.tv_usec - t ## _tstart.tv_usec \
							  + 1000000*( t ## _tv.tv_sec - t ## _tstart.tv_sec)) / 1000.0)

#endif /* TIMING */


#endif /* _ANET_H_ */
