#***************************************************************#
#* common.perl                                                 *#
#***************************************************************#

%ANET_TYPE_DEF	= (
  'Ubyte', "unsigned char",
#  'Byte', "signed char",
#  'Ushort', "unsigned short",
#  'Short', "signed short",
  'Uint', "unsigned int",
  'Int', "signed int",
#  'Float', "float",
#  'Double', "Double",
  );

@ANET_TYPES = keys %ANET_TYPE_DEF;

%ASSOC_FOR_TYPE	= (
  'Ubyte'		=> ['Max', 'Or', 'Plus', 'Mult'],
  'Byte'		=> ['Max', 'Or', 'Plus', 'Mult'],
  'Uint'		=> ['Max', 'Or', 'Plus', 'Mult'],
  'Int'			=> ['Max', 'Or', 'Plus', 'Mult'],
  'Float'		=> ['Max', 'Or', 'Plus', 'Mult'],
  'Double'		=> ['Max', 'Or', 'Plus', 'Mult'],
  );

%DIRECT_FOR_TYPE = (
  'Ubyte'		=> ['Max', 'Min', 'Or', 'And', 'Minc'],
  'Byte'		=> ['Max', 'Min', 'Or', 'And', 'Minc'],
  'Uint'		=> ['Max', 'Min', 'Or', 'And', 'Minc'],
  'Int'			=> ['Max', 'Min', 'Or', 'And', 'Minc'],
  'Float'		=> ['Max', 'Min', 'Minc'],
  'Double'		=> ['Max', 'Min', 'Minc'],
  );

%SOPS_FOR_DIRECT = (
  'Max', 'Max',
  'Min', 'Min',
  'Or', 'Or',
  'And', 'And',
  'Minc', 'Min',
  );

@WDIRECT_FOR_TYPE    = (
  'Ubyte'		=> ['Mincw'],
  'Byte'		=> ['Mincw'],
  'Uint'		=> ['Mincw'],
  'Int'			=> ['Mincw'],
  'Float'		=> ['Mincw'],
  'Double'		=> ['Mincw'],
  );

%STEP_FOR_TYPE	= (
  'Ubyte'		=> ['Max', 'Min', 'Or', 'And', 'Plus', 'Minus'],
  'Byte'		=> ['Max', 'Min', 'Or', 'And', 'Plus', 'Minus'],
  'Uint'		=> ['Max', 'Min', 'Or', 'And', 'Plus', 'Minus'],
  'Int'			=> ['Max', 'Min', 'Or', 'And', 'Plus', 'Minus'],
  'Float'		=> ['Max', 'Min', 'Plus', 'Minus'],
  'Double'		=> ['Max', 'Min', 'Plus', 'Minus'],
  );

%ELMTWISE_FOR_TYPE	= (
  'Ubyte'		=> ['Max', 'Min', 'Or', 'And', 'Xor', 'Plus', 'Minus', 'Mult', 'Div', 'Shl', 'Shr', 'Mod'],
  'Byte'		=> ['Max', 'Min', 'Or', 'And', 'Xor', 'Plus', 'Minus', 'Mult', 'Div', 'Shl', 'Shr', 'Mod'],
  'Uint'		=> ['Max', 'Min', 'Or', 'And', 'Xor', 'Plus', 'Minus', 'Mult', 'Div', 'Shl', 'Shr', 'Mod'],
  'Int'			=> ['Max', 'Min', 'Or', 'And', 'Xor', 'Plus', 'Minus', 'Mult', 'Div', 'Shl', 'Shr', 'Mod'],
  'Float'		=> ['Max', 'Min', 'Plus', 'Minus', 'Mult', 'Div'],
  'Double'		=> ['Max', 'Min', 'Plus', 'Minus', 'Mult', 'Div'],
  );

%BOOLWISE_FOR_TYPE	= (
  'Ubyte'		=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  'Byte'		=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  'Uint'		=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  'Int'			=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  'Float'		=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  'Double'		=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  );

%REDUCE_FOR_TYPE	= (
  'Ubyte'		=> ['Max', 'Min', 'Or', 'And', 'Xor', 'Plus', 'Mult'],
  'Byte'		=> ['Max', 'Min', 'Or', 'And', 'Xor', 'Plus', 'Mult'],
  'Uint'		=> ['Max', 'Min', 'Or', 'And', 'Xor', 'Plus', 'Mult'],
  'Int'			=> ['Max', 'Min', 'Or', 'And', 'Xor', 'Plus', 'Mult'],
  'Double'		=> ['Max', 'Min', 'Plus', 'Mult'],
  'Float'		=> ['Max', 'Min', 'Plus', 'Mult'],
  );

%LWBINARY_FOR_TYPE	= (
  'Ubyte'		=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  'Byte'		=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  'Uint'		=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  'Int'			=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  'Float'		=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  'Double'		=> ['Equal', 'Diff', 'Inf', 'Sup', 'InfEqual', 'SupEqual'],
  );

%LWUNARY_FOR_TYPE	= (
  'Ubyte'		=> ['One', 'Zero'],
  'Byte'		=> ['One', 'Zero'],
  'Uint'		=> ['One', 'Zero'],
  'Int'			=> ['One', 'Zero'],
  'Float'		=> ['One', 'Zero'],
  'Double'		=> ['One', 'Zero'],
  );

%LOPOFF_FOR_TYPE	= (
  'Ubyte'		=> ['One', 'Zero'],
  'Byte'		=> ['One', 'Zero'],
  'Uint'		=> ['One', 'Zero'],
  'Int'			=> ['One', 'Zero'],
  'Float'		=> ['One', 'Zero'],
  'Double'		=> ['One', 'Zero'],
  );

%SELF_FOR_TYPE	= (
  'Ubyte'		=> ['Complement', 'Address', 'Rand'],
  'Byte'		=> ['Complement', 'Address', 'Abs', 'Rand'],
  'Uint'		=> ['Complement', 'Address', 'Rand'],
  'Int'			=> ['Complement', 'Address', 'Abs', 'Rand'],
  'Float'		=> ['Address', 'Abs'],
  'Double'		=> ['Address', 'Abs'],
  );

%SYMBOL = (
  'Plus','+',
  'Minus','-',
  'Mult','*',
  'Div','/',
  'Mod','%',
  'And','&',
  'Or','|',
  'Xor','^',
  'Shl','<<',
  'Shr','>>',
  'Sup','>',
  'Inf','<',
  'SupEqual','>=',
  'InfEqual','<=',
  'Equal','==',
  'Diff','!=',
  );

%CODE_FOR_BINARY	= (
  'Plus', '(x) + (y)',
  'Minus', '(x) - (y)',
  'Mult', '(x) * (y)',
  'Div', '(x) / (y)',
  'And', '(x) & (y)',
  'Or', '(x) | (y)',
  'Xor', '(x) ^ (y)',
  'Shr', '(x) >> (Int)(y)',
  'Shl', '(x) << (Int)(y)',
  'Max', '((x) > (y))? (x) : (y)',
  'Min', '((x) < (y))? (x) : (y)',
  'Mod', '(x) % (y)',
  'Minc', '((x) < (y) + 1)? (x) : ((y)+1)',
  );

%CODE_FOR_WBIN    = (
  'Mincw', '((x) < ((y) + (w)))? (x) : (y)+(w)'
  );

%CODE_FOR_BOOL   = (
  'Equal', '((x) == (y))',
  'Diff', '((x) != (y))',
  'Sup', '((x) > (y))',
  'Inf', '((x) < (y))',
  'SupEqual', '((x) >= (y))',
  'InfEqual', '((x) <= (y))',
  );

%CODE_FOR_SELF   = (
  'Complement', '(~(x))',
  'Address', '(n)',
  'Abs', '(((x) >= 0)? (x) : -(x))',
  'Rand', '(random() % x)',
  );

%CODE_FOR_UBOOL   = (
  'One', '((x) != 0)',
  'Zero', '((x) == 0)',
  );

%IDENTITY	= (
  'Plus'.'Uint', '0x00000000u',
  'Minus'.'Uint', '0x00000000u',
  'Mult'.'Uint', '0x00000001u',
  'Div'.'Uint', '0x00000001u',
  'And'.'Uint', '0xffffffffu',
  'Or'.'Uint', '0x00000000u',
  'Xor'.'Uint', '0x00000000u',
  'Shr'.'Uint', '0u',
  'Shl'.'Uint', '0u',
  'Max'.'Uint', '0u',
  'Min'.'Uint', 'UINT_MAX',
  'Mod'.'Uint', 'UINT_MAX',

  'Plus'.'Int', '0',
  'Minus'.'Int', '0',
  'Mult'.'Int', '1',
  'Div'.'Int', '1',
  'And'.'Int', '0xffffffff',
  'Or'.'Int', '0x00000000',
  'Xor'.'Int', '0x00000000',
  'Shr'.'Int', '0',
  'Shl'.'Int', '0',
  'Max'.'Int', 'INT_MIN',
  'Min'.'Int', 'INT_MAX',
  'Mod'.'Int', 'INT_MAX',

  'Plus'.'Ubyte', '0x00',
  'Minus'.'Ubyte', '0x00',
  'Mult'.'Ubyte', '0x00',
  'Div'.'Ubyte', '0x01',
  'And'.'Ubyte', '0xff',
  'Or'.'Ubyte', '0x00',
  'Xor'.'Ubyte', '0x00',
  'Shr'.'Ubyte', '0',
  'Shl'.'Ubyte', '0',
  'Max'.'Ubyte', '0',
  'Min'.'Ubyte', 'UCHAR_MAX',
  'Mod'.'Ubyte', 'UCHAR_MAX',
  
  'Plus'.'Float', '0.0',
  'Minus'.'Float', '0.0',
  'Mult'.'Float', '0.0',
  'Div'.'Float', '1.0',
  'Max'.'Float', '-MAXFLOAT',
  'Min'.'Float', 'MAXFLOAT',

  'Plus'.'Double', '0.0',
  'Minus'.'Double', '0.0',
  'Mult'.'Double', '0.0',
  'Div'.'Double', '1.0',
  'Max'.'Double', '-MAXFLOAT',
  'Min'.'Double', 'MAXFLOAT',
    );

@BOPERATOR = ();
push @BOPERATOR,(@NOPERATOR,@SOPERATOR);
