/*
 *  assoc.c
 *  Anet
 *
 *  Created by Nicolas Sicard on Mon Nov 25 2002.
 *  Copyright (c) 2002 IEF. All rights reserved.
 *
 */


#include "assoc.h"
#include "compscan.h"
#include "diffusion.h"
#include "nipborgefor.h"


void ASSOC(Max , Ubyte)(Ubyte *res, Ubyte *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Max , Ubyte)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Max , Ubyte)(Ubyte *res, Ubyte *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Max , Ubyte)(res, mask, core, flag);
}

void ASSOC(Or , Ubyte)(Ubyte *res, Ubyte *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Or , Ubyte)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Or , Ubyte)(Ubyte *res, Ubyte *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Or , Ubyte)(res, mask, core, flag);
}

void ASSOC(Plus , Ubyte)(Ubyte *res, Ubyte *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Plus , Ubyte)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Plus , Ubyte)(Ubyte *res, Ubyte *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Plus , Ubyte)(res, mask, core, flag);
}

void ASSOC(Mult , Ubyte)(Ubyte *res, Ubyte *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Mult , Ubyte)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Mult , Ubyte)(Ubyte *res, Ubyte *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Mult , Ubyte)(res, mask, core, flag);
}

void ASSOC(Max , Uint)(Uint *res, Uint *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Max , Uint)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Max , Uint)(Uint *res, Uint *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Max , Uint)(res, mask, core, flag);
}

void ASSOC(Or , Uint)(Uint *res, Uint *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Or , Uint)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Or , Uint)(Uint *res, Uint *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Or , Uint)(res, mask, core, flag);
}

void ASSOC(Plus , Uint)(Uint *res, Uint *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Plus , Uint)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Plus , Uint)(Uint *res, Uint *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Plus , Uint)(res, mask, core, flag);
}

void ASSOC(Mult , Uint)(Uint *res, Uint *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Mult , Uint)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Mult , Uint)(Uint *res, Uint *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Mult , Uint)(res, mask, core, flag);
}

void ASSOC(Max , Int)(Int *res, Int *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Max , Int)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Max , Int)(Int *res, Int *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Max , Int)(res, mask, core, flag);
}

void ASSOC(Or , Int)(Int *res, Int *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Or , Int)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Or , Int)(Int *res, Int *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Or , Int)(res, mask, core, flag);
}

void ASSOC(Plus , Int)(Int *res, Int *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Plus , Int)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Plus , Int)(Int *res, Int *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Plus , Int)(res, mask, core, flag);
}

void ASSOC(Mult , Int)(Int *res, Int *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    ANET_RNET       *rnet;
    //NEW_TIME(RED);

    //START_TIME(RED);
    rnet = newRnet(core);
    rnet_reduce(rnet, mask);
    //rnet_print(rnet, AS_Width(core), 1);
    //END_TIME(RED);
    //PRINT_TIME(RED,"RED");
    COMPSCAN_ASSOC(Mult , Int)(res, src, rnet, core, flag);
    rnet_free(rnet);
}

void ASSOC_EXP(Mult , Int)(Int *res, Int *src, ANET_MASK *mask, ANET_CORE *core, int flag)
{
    NIPBORGEFOR_TWOPASS(Mult , Int)(res, mask, core, flag);
}
