/*
 *  rgraph.h
 *  Anet
 *
 *  Created by Nicolas on Thu Aug 28 2003.
 *  Copyright (c) 2003 IEF. All rights reserved.
 *
 * $Id: rgraph.h,v 1.1 2003/09/10 09:23:09 nico Exp $
 * $Log: rgraph.h,v $
 * Revision 1.1  2003/09/10 09:23:09  nico
 * Ajout au repertoire cvs
 *
 * Revision 1.1.1.1  2003/09/09 14:41:04  nico
 * Version 0.9
 *
 * Revision 1.4  2003/09/09 07:18:05  nico
 * Version fonctionnelle, version de test
 *
 * Revision 1.3  2003/09/02 11:14:38  nico
 * Passage des donnees pscc vers RNET_PARAM
 *
 */

#ifndef _RGRAPH_H_
#define _RGRAPH_H_

#include "core.h"

/* Link cell for list of component predecessors */
typedef struct RNET_LINK {
    unsigned			scc;						/* index of predecessor scc */
    struct RNET_LINK	*next;						/* next link cell in linked list */
} RNET_LINK;

/* Strong Connected Component data structure */
typedef struct {
    RNET_LINK	*links;								/* Linked list of scc dependancies */
} RNET_SCC;

/* Reduced graph data structure */
typedef struct {
    ANET_CORE	*core;								/* Relative anet core */
    unsigned	size;								/* Size of based graph (= sizeof core) */
	unsigned	compcount;							/* Number of strong connected components */
	unsigned	compcounts[ANET_MAX_CONCURRENCY];   /* Number of scc for each block in MT mode */
    RNET_SCC	*scc;								/* Array of strong connected components */
    unsigned	*label;								/* Array of node's component index in "scc" array*/
} ANET_RNET;

/* Return an allocated and initialized reduced net data structure address */
ANET_RNET *newRnet(ANET_CORE *core);
/* Release reduced net data structure memory */
void rnet_free(ANET_RNET *rnet);
/* Build preallocated and initialized rnet from subnet */
void rnet_reduce(ANET_RNET *rnet, ANET_MASK *subnet);
/* Print information about rnet with provided image width and flag selection */
void rnet_print(ANET_RNET *rnet, unsigned width, unsigned flag);

#endif /* _RGRAPH_H_ */
