/*
 *  topology.h
 *  Anet
 *
 *  Created by Nicolas Sicard on Tue Sep 03 2002.
 *  Copyright (c) 2002 IEF. All rights reserved.
 *
 *  $Id: topology.h,v 1.1.1.1 2003/09/09 14:41:04 nico Exp $
 *  $Log: topology.h,v $
 *  Revision 1.1.1.1  2003/09/09 14:41:04  nico
 *  Version 0.9
 *
 *  Revision 1.7  2003/07/23 12:39:27  nico
 *  Version fonctionnelle
 *
 *  Revision 1.6  2003/07/20 21:06:50  nico
 *  Correction diverses apres compilation -Wall, virtualisation et reduction pour vnet (virtualnet.c)
 *
 *  Revision 1.5  2003/07/10 22:51:32  nico
 *  Augmentation des dimensions maxi
 *
 *  Revision 1.4  2003/07/07 21:52:25  nico
 *  Modification des keywords CVS
 *
 *  Revision 1.3  2003/07/07 21:31:36  nico
 *  Retrait des mot-cles CVS pour cause d'incompatibilite avec perl tpp !
 *
 *  Revision 1.2  2003/07/07 20:23:32  nico
 *  Ajout de mot-cles CVS (auteur, revision, log)
 *
 */

#ifndef _TOPOLOGY_H_
#define _TOPOLOGY_H_

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pthread.h>

#include "operator.h"

#define ANET_MASK	Ubyte
//typedef unsigned char ANET_MASK;		// 8-connexity
#define ANET_MASK_SIZE (sizeof(ANET_MASK)<<3)

/* Topology description object */
typedef struct ANET_TOPOLOGY {
    unsigned width, height, size;		// image dimensions
} ANET_TOPOLOGY;

#define ANET_MIN_WIDTH		3
#define ANET_MAX_WIDTH		0xfffff
#define ANET_MIN_HEIGHT		3
#define ANET_MAX_HEIGHT		0xfffff
#define ANET_MAX_SIZE		0xefffffff

/* Some usefull macros */
#define AT_Width(topo) ((topo)->width)
#define AT_Height(topo) ((topo)->height)
#define AT_Size(topo) ((topo)->size)

/* some predefined constants and local masks */
enum{
  N=0,
  NE=1,
  E=2,
  SE=3,
  S=4,
  SW=5,
  W=6,
  NW=7
};
  
enum{
  mE = (1<<E),
  mNE = (1<<NE),
  mN = (1<<N),
  mNW = (1<<NW),
  mW = (1<<W),
  mSW = (1<<SW),
  mS = (1<<S),
  mSE = (1<<SE)
};


/* Initialize topology structure */
ANET_TOPOLOGY *newTopology(unsigned width, unsigned height);
ANET_TOPOLOGY *newTopologyFromCLI(int argc, char** argv);

/* Random acces to a node's neighbors list */
extern int **t_rel_mesh;
#define t_neighbors_rel(i) (t_rel_mesh[i])
void t_neighbors(ANET_TOPOLOGY *topo, unsigned i, unsigned *neighb);
#endif /* _TOPOLOGY_H_ */
