/*
 *  vreduce.c
 *  Anet
 *
 *  Created by Nicolas on Mon Apr 19 2004.
 *  Copyright (c) 2004 IEF. All rights reserved.
 *
 */


#include "vreduce.h"


void VEXTEND( Uint )(Uint *vp, Uint *p, ANET_VNET *vnet, unsigned flag)
{
		unsigned	i;

		for (i = 0; i < vnet->size; i++)
			p[i] = vp[vnet->label[i]];
}

void VREDUCE_BIN( Max , Uint )(Uint *vp, Uint *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0u;
	for (i = 0; i < vnet->size; i++)
		Max(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Min , Uint )(Uint *vp, Uint *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = UINT_MAX;
	for (i = 0; i < vnet->size; i++)
		Min(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Or , Uint )(Uint *vp, Uint *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0x00000000u;
	for (i = 0; i < vnet->size; i++)
		Or(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( And , Uint )(Uint *vp, Uint *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0xffffffffu;
	for (i = 0; i < vnet->size; i++)
		And(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Xor , Uint )(Uint *vp, Uint *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0x00000000u;
	for (i = 0; i < vnet->size; i++)
		Xor(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Plus , Uint )(Uint *vp, Uint *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0x00000000u;
	for (i = 0; i < vnet->size; i++)
		Plus(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Mult , Uint )(Uint *vp, Uint *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0x00000001u;
	for (i = 0; i < vnet->size; i++)
		Mult(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}

void VELMTWISE_BIN( Max , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Max(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Max(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Min , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Min(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Min(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Or , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Or(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Or(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( And , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			And(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			And(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Xor , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Xor(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Xor(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Plus , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Plus(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Plus(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Minus , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Minus(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Minus(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Mult , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Mult(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Mult(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Div , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Div(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Div(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Shl , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Shl(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Shl(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Shr , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Shr(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Shr(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Mod , Uint )(Uint *res, Uint *src1, Uint *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Mod(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Mod(res[i], src1[i], src2[i], i);
	}
}


void VEXTEND( Ubyte )(Ubyte *vp, Ubyte *p, ANET_VNET *vnet, unsigned flag)
{
		unsigned	i;

		for (i = 0; i < vnet->size; i++)
			p[i] = vp[vnet->label[i]];
}

void VREDUCE_BIN( Max , Ubyte )(Ubyte *vp, Ubyte *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0;
	for (i = 0; i < vnet->size; i++)
		Max(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Min , Ubyte )(Ubyte *vp, Ubyte *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = UCHAR_MAX;
	for (i = 0; i < vnet->size; i++)
		Min(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Or , Ubyte )(Ubyte *vp, Ubyte *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0x00;
	for (i = 0; i < vnet->size; i++)
		Or(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( And , Ubyte )(Ubyte *vp, Ubyte *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0xff;
	for (i = 0; i < vnet->size; i++)
		And(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Xor , Ubyte )(Ubyte *vp, Ubyte *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0x00;
	for (i = 0; i < vnet->size; i++)
		Xor(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Plus , Ubyte )(Ubyte *vp, Ubyte *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0x00;
	for (i = 0; i < vnet->size; i++)
		Plus(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Mult , Ubyte )(Ubyte *vp, Ubyte *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0x00;
	for (i = 0; i < vnet->size; i++)
		Mult(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}

void VELMTWISE_BIN( Max , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Max(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Max(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Min , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Min(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Min(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Or , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Or(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Or(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( And , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			And(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			And(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Xor , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Xor(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Xor(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Plus , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Plus(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Plus(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Minus , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Minus(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Minus(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Mult , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Mult(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Mult(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Div , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Div(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Div(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Shl , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Shl(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Shl(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Shr , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Shr(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Shr(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Mod , Ubyte )(Ubyte *res, Ubyte *src1, Ubyte *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Mod(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Mod(res[i], src1[i], src2[i], i);
	}
}


void VEXTEND( Int )(Int *vp, Int *p, ANET_VNET *vnet, unsigned flag)
{
		unsigned	i;

		for (i = 0; i < vnet->size; i++)
			p[i] = vp[vnet->label[i]];
}

void VREDUCE_BIN( Max , Int )(Int *vp, Int *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = INT_MIN;
	for (i = 0; i < vnet->size; i++)
		Max(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Min , Int )(Int *vp, Int *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = INT_MAX;
	for (i = 0; i < vnet->size; i++)
		Min(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Or , Int )(Int *vp, Int *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0x00000000;
	for (i = 0; i < vnet->size; i++)
		Or(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( And , Int )(Int *vp, Int *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0xffffffff;
	for (i = 0; i < vnet->size; i++)
		And(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Xor , Int )(Int *vp, Int *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0x00000000;
	for (i = 0; i < vnet->size; i++)
		Xor(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Plus , Int )(Int *vp, Int *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 0;
	for (i = 0; i < vnet->size; i++)
		Plus(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}
void VREDUCE_BIN( Mult , Int )(Int *vp, Int *p, ANET_VNET *vnet, unsigned flag)
{
	unsigned	i;
	
	for (i = 0; i < vnet->compcount; i++)
		vp[i] = 1;
	for (i = 0; i < vnet->size; i++)
		Mult(vp[vnet->label[i]], vp[vnet->label[i]], p[i], i);
}

void VELMTWISE_BIN( Max , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Max(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Max(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Min , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Min(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Min(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Or , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Or(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Or(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( And , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			And(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			And(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Xor , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Xor(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Xor(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Plus , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Plus(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Plus(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Minus , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Minus(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Minus(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Mult , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Mult(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Mult(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Div , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Div(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Div(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Shl , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Shl(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Shl(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Shr , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Shr(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Shr(res[i], src1[i], src2[i], i);
	}
}
void VELMTWISE_BIN( Mod , Int )(Int *res, Int *src1, Int *src2, ANET_CORE *core, unsigned size, unsigned flag)
{
	unsigned	i;
	
	if (flag & ANET_EXTENDED) {
		for (i = 0; i < size; i++)
			Mod(res[i], src1[i], *src2, i);		
	} else {
		for (i = 0; i < size; i++)
			Mod(res[i], src1[i], src2[i], i);
	}
}

