/*
 *  pvar.cc
 *  Anet
 *
 *  Created by Nicolas Sicard on Tue Jan 21 2003.
 *  Copyright (c) 2003 IEF. All rights reserved.
 *
 */

/*
    Perl generated file
    Pvar object implementation -- encapsulates Anet Core C functions
*/

:do $datafile ;

#if ANET_SYS == Darwin
#include <limits.h>
#else
#include <values.h>
#endif

#include <ostream.h>

#include "pvar.h"
#include "pvarbool.h"
#include "subnet.h"

:foreach $TYPE (@ANET_TYPES) {
/* Apply operation */
/*
Pvar$TYPE& Pvar$TYPE::Apply($TYPE (*func)( $TYPE ))
{
	SELF_APPLY( $TYPE )(pTab, pTab, func, Size(), &topology, &context, 0, &archi);
  return *this;
}
*/

/* Binary operations */
Pvar$TYPE& Pvar$TYPE::operator=(const Pvar$TYPE& ps)
{
  ELMTWISE_BIN( Copy , $TYPE )(pvBuffer, ps.getBuffer(), core, 0);
  return *this;
}

Pvar$TYPE& Pvar$TYPE::operator=(const $TYPE & t)
{
  $TYPE tmp = t;
  ELMTWISE_BIN( Copy , $TYPE )(pvBuffer, &tmp, core, ANET_EXTENDED);
  return *this;
}

:foreach $OP (@{$ELMTWISE_FOR_TYPE{$TYPE}}) {
Pvar$TYPE& Pvar$TYPE::EqualName( $OP )(const Pvar$TYPE& ps)
{
  ELMTWISE_BIN( $OP , $TYPE )(pvBuffer, pvBuffer, ps.getBuffer(), core, 0);
  return *this;
}

Pvar$TYPE& Pvar$TYPE::EqualName( $OP )(const $TYPE & t)
{
  $TYPE tmp = t;
  ELMTWISE_BIN( $OP , $TYPE )(pvBuffer, pvBuffer, &tmp, core, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
:if ((grep /^$OP$/ , keys %SYMBOL) != 0) {
Pvar$TYPE& Pvar$TYPE::operator$SYMBOL{$OP}=(const Pvar$TYPE& p)
{
  return EqualName( $OP )(p);
}

Pvar$TYPE& Pvar$TYPE::operator$SYMBOL{$OP}=(const $TYPE & t)
{
  return EqualName( $OP )(t);
}

Pvar$TYPE Pvar$TYPE::operator$SYMBOL{$OP}(const Pvar$TYPE& ps)
{
  Pvar$TYPE r;

  ELMTWISE_BIN( $OP , $TYPE )(r.getBuffer(), pvBuffer, ps.getBuffer(), core, 0);
  return r;
}

Pvar$TYPE Pvar$TYPE::operator$SYMBOL{$OP}(const $TYPE & t)
{
  Pvar$TYPE r;
  $TYPE tmp = t;

  ELMTWISE_BIN( $OP , $TYPE )(r.getBuffer(), pvBuffer, &tmp, core, ANET_EXTENDED);
  return r;
}
:}
:}

/* Boolean instructions */
:foreach $OP (@{$BOOLWISE_FOR_TYPE{$TYPE}}) {

PvarBool Pvar$TYPE::Is( $OP )(const Pvar$TYPE& ps) const
{
  PvarBool r;

  BOOLWISE_BIN( $OP , $TYPE )(r.getBuffer(), pvBuffer, ps.getBuffer(), core, 0);
  return r;
}

PvarBool Pvar$TYPE::Is( $OP )(const $TYPE & t) const
{
  PvarBool r;
  $TYPE tmp = t;

  BOOLWISE_BIN( $OP , $TYPE )(r.getBuffer(), pvBuffer, &tmp, core, ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
:if ((grep /^$OP$/ , keys %SYMBOL) != 0) {
PvarBool Pvar$TYPE::IsSymb( $SYMBOL{$OP} )(const Pvar$TYPE& ps) const
{
  return Pvar$TYPE::Is( $OP )(ps);
}

PvarBool Pvar$TYPE::IsSymb( $SYMBOL{$OP})(const $TYPE & t) const
{
  return Pvar$TYPE::Is( $OP )(t);
}
:}
:}

/* Step Associations */
:foreach $OP (@{$STEP_FOR_TYPE{$TYPE}}) {
void Pvar$TYPE::StepAssoc( $OP )(Subnet& s, const Pvar$TYPE& ps)
{
  STEP_BIN( $OP , $TYPE )(pvBuffer, ps.getBuffer(), s.getBuffer(), core, 0);
}

void Pvar$TYPE::StepAssocEx( $OP )(Subnet& s, const Pvar$TYPE& ps)
{
  STEP_BIN( $OP , $TYPE )(pvBuffer, ps.getBuffer(), s.getBuffer(), core, ANET_EXCLUSIVE);
}

:}

/* NRStep Associations */
void Pvar$TYPE::StepAssocNr(void *op, Subnet& s, const Pvar$TYPE& ps)
{
  STEP_NR( $TYPE )(op, pvBuffer, ps.getBuffer(), s.getBuffer(), core, 0);
}

/* Direct Associations (r-ops & s-ops) */
:foreach $OP (@{$DIRECT_FOR_TYPE{$TYPE}}) {
void Pvar$TYPE::DirectAssoc( $OP )(Subnet& s, const Pvar$TYPE& ps, int cvx)
{
  DIRECT_ASSOC($OP , $TYPE)(pvBuffer, ps.getBuffer(), s.getBuffer(), core, cvx);
}
:}

/* Global scan */
:foreach $OP (@{$REDUCE_FOR_TYPE{$TYPE}}) {
$TYPE Pvar$TYPE::Global$OP(unsigned flag)
{
  $TYPE r;

  REDUCE_BIN( $OP , $TYPE )(&r, pvBuffer, core, flag);
  return r;
}
:}

/* Associations */

:foreach $OP (@{$ASSOC_FOR_TYPE{$TYPE}}) {
void Pvar$TYPE::Assoc( $OP )(Subnet& s, const Pvar$TYPE& ps, int cvx)
{
    ANET_RNET       *rnet;

    rnet = (s.rnet != NULL)? s.rnet : newRnet(core);
    if (s.rnet == NULL) rnet_reduce(rnet, s.getBuffer());
    COMPSCAN_ASSOC($OP , $TYPE)(pvBuffer, ps.getBuffer(), rnet, core, cvx);
    if (s.rnet == NULL) s.rnet = rnet;
}
:}

/* Self operation (self-address etc.) */
:foreach $OP (@{$SELF_FOR_TYPE{$TYPE}}) {
void Pvar$TYPE::Self($OP)(unsigned flag)
{
  ELMTWISE_SELF( $OP , $TYPE )(pvBuffer, pvBuffer, core, flag);
}
:}

:foreach $OP (keys %SELFOPCODE) {
void Pvar$TYPE::Self($OP)(const Pvar$TYPE& ps, unsigned flag)
{
  ELMTWISE_SELF( $OP , $TYPE )(pvBuffer, ps.getBuffer(), core, flag);
}
:}

/* Link-with / Lop-offs instructions as Pvar friend functions */
:foreach $OP (@{$LWBINARY_FOR_TYPE{$TYPE}}) {
void LinkWith( $OP )(Subnet& s, const Pvar$TYPE& loc, const Pvar$TYPE& dist)
{
  LINK_WITH( $OP , $TYPE )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), NULL, Anet::Core(), 0);
}
void LinkWith( $OP )(Subnet& s, const Pvar$TYPE& loc, const Pvar$TYPE& dist, Subnet& m)
{
  LINK_WITH( $OP , $TYPE )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), m.getBuffer(), Anet::Core(), 0);
}
:}

:foreach $OP (@{$LWUNARY_FOR_TYPE{$TYPE}}) {
void LinkWith( $OP )(Subnet& s, const Pvar$TYPE& dist)
{
  LINK_WITH_PRED( $OP , $TYPE )(s.getBuffer(), dist.getBuffer(), Anet::Core(), 0);
}
:}

:foreach $OP (@{$LOPOFF_FOR_TYPE{$TYPE}}) {
void LopOff( $OP )(Subnet& s, const Pvar$TYPE& dist)
{
  LOP_OFF( $OP , $TYPE )(s.getBuffer(), dist.getBuffer(), Anet::Core(), 0);
}
:}

:}
