/*
 *  pvarbool.cc
 *  Anet
 *
 *  Created by Nicolas Sicard on Tue Jan 21 2003.
 *  Copyright (c) 2003 IEF. All rights reserved.
 *
 * $Author: nico $
 * $Revision: 1.1.1.1 $
 * $Log: pvarbool.cc,v $
 * Revision 1.1.1.1  2003/09/09 14:41:04  nico
 * Version 0.9
 *
 * Revision 1.2  2003/07/07 19:05:38  nico
 * Ajout de mot-cles CVS (auteur, revision, log)
 *
 */

/*
 NOTE : some methods are not yet parallelized
 */

#include "pvarbool.h"

PvarBool::PvarBool() : PvarUbyte() {}
PvarBool::PvarBool(const PvarBool& pb) : PvarUbyte(pb) {}

PvarBool::PvarBool(const int& b) : PvarUbyte()
{
  Ubyte m = (b != 0)? (Ubyte)0xff : (Ubyte)0x00;
  ELMTWISE_BIN( Copy , Ubyte )(pvBuffer, &m, core, ANET_EXTENDED);
  /*for (unsigned i = 0; i < Size(); i++)
    pvBuffer[i] = m;*/
}

PvarBool::~PvarBool() {}

void PvarBool::Not()
{
    Ubyte m = 0xff;
    ELMTWISE_BIN( Xor , Ubyte )(pvBuffer, pvBuffer, &m, core, ANET_EXTENDED);
    /*for (unsigned i = 0; i < Size(); i++)
        pvBuffer[i] ^= 0xff;*/
}

PvarBool& PvarBool::operator=(const PvarBool& pb)
{
  ELMTWISE_BIN( Copy , Ubyte )(pvBuffer, pb.getBuffer(), core, 0);
  //memcpy(pvBuffer,pb.pvBuffer,Size()*sizeof(Ubyte));
  return *this;
}

PvarBool PvarBool::operator==(const PvarBool& pb) const
{
  PvarBool r;
  for (unsigned i = 0; i < Size(); i++)
    r.pvBuffer[i] = ~(pvBuffer[i] ^ pb.pvBuffer[i]);
  return r;
}

PvarBool PvarBool::operator!=(const PvarBool& pb) const
{
    PvarBool r;
    ELMTWISE_BIN( Xor , Ubyte )(r.getBuffer(), pvBuffer, pb.getBuffer(), core, 0);
  /*for (unsigned i = 0; i < Size(); i++)
    r.pvBuffer[i] = pvBuffer[i] ^ pb.pvBuffer[i];*/
  return r;
}

PvarBool PvarBool::operator&&(const PvarBool& pb) const
{
    PvarBool r;
    ELMTWISE_BIN( And , Ubyte )(r.getBuffer(), pvBuffer, pb.getBuffer(), core, 0);
    /*for (unsigned i = 0; i < Size(); i++)
        r.pvBuffer[i] = pvBuffer[i] & pb.pvBuffer[i];*/
  return r;
}

PvarBool PvarBool::operator||(const PvarBool& pb) const
{
    PvarBool r;
    ELMTWISE_BIN( Or , Ubyte )(r.getBuffer(), pvBuffer, pb.getBuffer(), core, 0);
    /*for (unsigned i = 0; i < Size(); i++)
        r.pvBuffer[i] = pvBuffer[i] | pb.pvBuffer[i];*/
  return r;
}

PvarBool operator!(const PvarBool& pb)
{
  PvarBool r;
  for (unsigned i = 0; i < pb.Size(); i++)
    r.pvBuffer[i] = ~pb.pvBuffer[i];
  return r;
}
