/*
 *  pvarbool.h
 *  Anet
 *
 *  Created by Nicolas Sicard on Tue Jan 21 2003.
 *  Copyright (c) 2003 IEF. All rights reserved.
 *
 * $Author: nico $
 * $Revision: 1.1.1.1 $
 * $Log: pvarbool.h,v $
 * Revision 1.1.1.1  2003/09/09 14:41:04  nico
 * Version 0.9
 *
 * Revision 1.2  2003/07/07 19:05:38  nico
 * Ajout de mot-cles CVS (auteur, revision, log)
 *
 */

#ifndef _PVARBOOL_H_
#define _PVARBOOL_H_

#include "pvar.h"

#define ANET_TRUE	0xff
#define ANET_FALSE   0x00

class PvarBool : protected PvarUbyte{
    /*
  friend ostream& operator<<(ostream& out, const PvarBool& pb){
    for(unsigned i = 0; i < pb.Size(); i++)
      out << (pb.pvBuffer[i] != 0) << " ";
    return out;
  }
    */
public:
  PvarBool();
  PvarBool(const PvarBool& pb);
  PvarBool(const int& b);
  ~PvarBool();

  /* self-apply not operator */
  void Not();

  /* return if nth node is true or false*/
  int operator()(unsigned n) const {
    return pvBuffer[n] != (unsigned char)0x00;
  }

  /* Set the nth node to true */
  void Set(unsigned n){
      pvBuffer[n] = (unsigned char)0xff;
  }
  /* Set the nth node to false */
  void Unset(unsigned n){
    pvBuffer[n] = (unsigned char)0x00;
  }

  PvarBool& operator=(const PvarBool&);

  PvarBool operator==(const PvarBool&) const;
  PvarBool operator!=(const PvarBool&) const;
  PvarBool operator&&(const PvarBool&) const;
  PvarBool operator||(const PvarBool&) const;

  unsigned char *getBuffer() const { return pvBuffer; }
  unsigned Size() const { return PvarUbyte::Size(); }
  friend PvarBool operator!(const PvarBool&);
};

#endif
