/*
 *  pvmacros.h
 *  Anet
 *
 *  Created by Nicolas Sicard on Tue Jan 21 2003.
 *  Copyright (c) 2003 IEF. All rights reserved.
 *
 * $Author: nico $
 * $Revision: 1.1.1.1 $
 * $Log: pvmacros.h,v $
 * Revision 1.1.1.1  2003/09/09 14:41:04  nico
 * Version 0.9
 *
 * Revision 1.3  2003/07/21 13:38:18  nico
 * AJout d'un appel de LinkWithOp avec un subnet masque
 *
 * Revision 1.2  2003/07/07 19:08:22  nico
 * Ajout de mot-cles CVS (auteur, revision, log)
 *
 */

/*
 Macros used to simplify code reading ...
 */

/* Macros for easier string concatenation */
#define StepAssoc(op) op ## StepAssoc
#define StepAssocEx(op) op ## StepAssocEx
#define EqualName(op) op ## Equal
#define EqualSymb(s) operator ## s ## =
#define ExtendSymb(s) operator ## s
#define Is(op) Is ## op
#define IsSymb(s) operator s
#define Self(op) Self ## op
#define DirectAssoc(op) op ## DirectAssoc
#define DirectAssoc_old(op) op ## DirectAssoc_old
#define Assoc(op) op ## Assoc
#define Assoc_exp(op) op ## Assoc_exp
#define WDirectAssoc(op) op ## WDirectAssoc
#define LinkWith(op) LinkWith ## op ## s
#define LopOff(op) LopOff ## op ## s


#define INTERFACE_BINEXT(op,T) \
public: \
Pvar ## T & op ## Equal(const Pvar ## T &); \
Pvar ## T & op ## Equal(const T &);

#define INTERFACE_BINEXT_SYMB(op,s,T) \
public: \
Pvar ## T & operator s ## =(const Pvar ## T &); \
Pvar ## T & operator s ## =(const T &); \
Pvar ## T operator s(const Pvar ## T &); \
Pvar ## T operator s(const T &);

#define INTERFACE_SELFEXT(op,T) \
public: \
void Self ## op(unsigned = ANET_WITHCONTEXT); \
void Self ## op(const Pvar ## T &, unsigned = ANET_WITHCONTEXT);

#define INTERFACE_SELFEXT_SYMB(op,s,T) \
public: \
friend Pvar ## T operator ## s ## (const Pvar ## T & p){ \
  Pvar ## T r; \
    Self ## op(r,p,ANET_WOCONTEXT); \
      return r; \
}
/*
#define INTERFACE_BOOLEXT(op,T) \
public: \
PvarBool Is ## op(const Pvar ## T &) const; \
PvarBool Is ## op(const T &) const;

#define INTERFACE_BOOLEXT_SYMB(op,s,T) \
public: \
PvarBool operator ## s(const Pvar ## T &) const; \
PvarBool operator ## s(const T &) const;
*/

#define INTERFACE_GLOBAL(op,T) \
public: \
T Global ## op(unsigned = ANET_WITHCONTEXT);

#define INTERFACE_STEP(op,T) \
public: \
void op ## StepAssoc(Subnet&, const Pvar ## T &); \
void op ## StepAssocEx(Subnet&, const Pvar ## T &);

#define INTERFACE_NRSTEP(T) \
public: \
void StepAssocNr(void *, Subnet&, const Pvar ## T &);

#define INTERFACE_ASSOC(op,T) \
public: \
void op ## Assoc(Subnet&, const Pvar ## T &, int=ANET_UNKNOWN);

//void op ## Assoc_exp(Subnet&, const Pvar ## T &, int=ANET_UNKNOWN);

/* DirectAssoc_old is for experimentation purpose only */
#define INTERFACE_DIRECT(op,T) \
public: \
void op ## DirectAssoc(Subnet&, const Pvar ## T &, int=ANET_UNKNOWN);

//  void op ## DirectAssoc(Rnet&, const Pvar ## T ## &);

#define INTERFACE_WDIRECT(op,T) \
public: \
void op ## WDirectAssoc(Subnet&, const Pvar ## T &, const WPvar<T>&, int=ANET_UNKNOWN);

#define INTERFACE_LINKWITH(op,T) \
public: \
friend void LinkWith ## op ## s(Subnet&, const Pvar ## T &, const Pvar ## T &); \
friend void LinkWith ## op ## s(Subnet&, const Pvar ## T &, const Pvar ## T &, Subnet&);

#define INTERFACE_LINKWITHPRED(op,T) \
public: \
friend void LinkWith ## op ## s(Subnet&, const Pvar ## T &);

#define INTERFACE_LOPOFF(op,T) \
public: \
friend void LopOff ## op ## s(Subnet&, const Pvar ## T &);


#define PVAR_INSTANCIATE(type) typedef Pvar ## type pvar_ ## type ## _class;
