/*
 *  vnet.h
 *  Anet
 *
 *  Created by Nicolas on Thu Jun 26 2003.
 *  Copyright (c) 2003 IEF. All rights reserved.
 *
 * $Author: nico $
 * $Revision: 1.1.1.1 $
 * $Log: vnet.h,v $
 * Revision 1.1.1.1  2003/09/09 14:41:04  nico
 * Version 0.9
 *
 * Revision 1.7  2003/07/25 16:20:42  nico
 * Retour dans le repertoire Source/Object
 *
 * Revision 1.1  2003/07/25 13:09:58  nico
 * Deplacement des fichier dans l'arborescence Virtual => bibliotheque a part
 *
 * Revision 1.6  2003/07/25 12:03:50  nico
 * Ajout d'un retour a la ligne en fin de fichier (gcc3.2)
 *
 * Revision 1.5  2003/07/23 12:39:37  nico
 * Version fonctionnelle
 *
 * Revision 1.4  2003/07/21 13:36:04  nico
 * Ajout d'un flag (impression des valeurs ou non) pour la methode print
 *
 * Revision 1.3  2003/07/20 21:07:21  nico
 * Correction diverses apres compilation -Wall, virtualisation et reduction pour vnet (vnet.cc)
 *
 * Revision 1.2  2003/07/07 19:08:22  nico
 * Ajout de mot-cles CVS (auteur, revision, log)
 *
 */

#ifndef _VNET_H_
#define _VNET_H_

extern "C" {
#include "vgraph.h"
}
#include "subnet.h"

#define WITH(v) Vnet::With(v);
#define ENDWITH Vnet::EndWith();

class VSubnet;
class VPvarBool;

class Vnet : public Anet{
    ANET_VNET	*vnet;
protected:
	static Vnet   *imp_vnet; // current implicit vnet
public:
	static void With(Vnet& );
	static void EndWith();
	static Vnet	*Implicit() { return imp_vnet; } 
public:
    Vnet();
    Vnet(const Vnet&);
    Vnet(Subnet& s, Subnet& mask, int flag=VNET_SINGLETONS);
//    Vnet(Subnet& s, unsigned mask_id = 0);
    ~Vnet();

    void Virtualize(Subnet&, Subnet&, int flag=VNET_SINGLETONS);
//    void Virtualize(Subnet&, unsigned mask_id = 0);

	void Virtualize(VSubnet&);
	
    Vnet& operator=(const Vnet&);

	unsigned	Size() const { return (vnet != NULL)? vnet->compcount : 0; }
public:
    unsigned ComponentCount() const { return vnet->compcount; }
    unsigned LinkCount() const { return vnet->linkcount; }
    ANET_VNET *VirtualNet() const { return vnet; }
    //for debugging purpose only !
    void Print(unsigned flag = 0);

	/* Set context status */
	static void Everywhere(const Vnet&);
	static void Where(const VPvarBool& cond, const Vnet&);
	static void Endwhere(const Vnet&);
	static void Elsewhere(const Vnet&);
	/* For use in implicit virtual net section */
	static void Everywhere();
	static void Where(const VPvarBool& cond);
	static void Endwhere();
	static void Elsewhere();
	
};

#endif /* _VNET_H_ */
