/*
 *  vpvar.cc
 *  Anet
 *
 *  Created by Nicolas Sicard on Mon Jul 21 2003.
 *  Copyright (c) 2003 IEF. All rights reserved.
 *
 */

/*
    Perl generated file
    VPvar object implementation -- encapsulates Anet Core C functions
*/


#if ANET_SYS == Darwin
#include <limits.h>
#else
#include <values.h>
#endif

#include <ostream.h>

#include "vpvar.h"
#include "vpvarbool.h"
#include "vsubnet.h"
#include "operator.h"
/* Use Anet Core C functions */
extern "C" {
#include "vlocal.h"
};


VPvarUint::VPvarUint()
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	vpvBuffer = new Uint[size = (Vnet::Implicit())->ComponentCount()];
}

VPvarUint::VPvarUint(const Uint & t)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	vpvBuffer = new Uint[size = (Vnet::Implicit())->ComponentCount()];
	*this = t;
}

VPvarUint::VPvarUint(const int s, const Uint *p)
{
	vpvBuffer = new Uint[size = s];
	if (p) memcpy(vpvBuffer, p, size * sizeof(Uint));
}

/* Global scan */
Uint VPvarUint::GlobalMax(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint r;

  VGLOBAL_BIN( Max , Uint )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Uint VPvarUint::GlobalMax(const Vnet& vnet, unsigned flag)
{
  Uint r;

  VGLOBAL_BIN( Max , Uint )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Uint VPvarUint::GlobalMin(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint r;

  VGLOBAL_BIN( Min , Uint )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Uint VPvarUint::GlobalMin(const Vnet& vnet, unsigned flag)
{
  Uint r;

  VGLOBAL_BIN( Min , Uint )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Uint VPvarUint::GlobalOr(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint r;

  VGLOBAL_BIN( Or , Uint )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Uint VPvarUint::GlobalOr(const Vnet& vnet, unsigned flag)
{
  Uint r;

  VGLOBAL_BIN( Or , Uint )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Uint VPvarUint::GlobalAnd(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint r;

  VGLOBAL_BIN( And , Uint )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Uint VPvarUint::GlobalAnd(const Vnet& vnet, unsigned flag)
{
  Uint r;

  VGLOBAL_BIN( And , Uint )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Uint VPvarUint::GlobalXor(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint r;

  VGLOBAL_BIN( Xor , Uint )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Uint VPvarUint::GlobalXor(const Vnet& vnet, unsigned flag)
{
  Uint r;

  VGLOBAL_BIN( Xor , Uint )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Uint VPvarUint::GlobalPlus(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint r;

  VGLOBAL_BIN( Plus , Uint )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Uint VPvarUint::GlobalPlus(const Vnet& vnet, unsigned flag)
{
  Uint r;

  VGLOBAL_BIN( Plus , Uint )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Uint VPvarUint::GlobalMult(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint r;

  VGLOBAL_BIN( Mult , Uint )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Uint VPvarUint::GlobalMult(const Vnet& vnet, unsigned flag)
{
  Uint r;

  VGLOBAL_BIN( Mult , Uint )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}

/* Self operation (self-address etc.) */
void VPvarUint::Self(Complement)(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  VELMTWISE_SELF( Complement , Uint )(vpvBuffer, vpvBuffer, Size(), vnet, flag);
}

void VPvarUint::Self(Complement)(const Vnet& vnet, unsigned flag)
{
  VELMTWISE_SELF( Complement , Uint )(vpvBuffer, vpvBuffer, Size(), vnet.VirtualNet(), flag);
}
void VPvarUint::Self(Address)(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  VELMTWISE_SELF( Address , Uint )(vpvBuffer, vpvBuffer, Size(), vnet, flag);
}

void VPvarUint::Self(Address)(const Vnet& vnet, unsigned flag)
{
  VELMTWISE_SELF( Address , Uint )(vpvBuffer, vpvBuffer, Size(), vnet.VirtualNet(), flag);
}
void VPvarUint::Self(Rand)(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  VELMTWISE_SELF( Rand , Uint )(vpvBuffer, vpvBuffer, Size(), vnet, flag);
}

void VPvarUint::Self(Rand)(const Vnet& vnet, unsigned flag)
{
  VELMTWISE_SELF( Rand , Uint )(vpvBuffer, vpvBuffer, Size(), vnet.VirtualNet(), flag);
}

/* BOOLEAN INSTRUCTION */
VPvarBool VPvarUint::Is( Equal )(const VPvarUint& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Equal , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUint::Is( Equal )(const Uint & t) const
{
  VPvarBool r(Size(), NULL);
  Uint tmp = t;

  VBOOLWISE_BIN( Equal , Uint )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUint::IsSymb( == )(const VPvarUint& ps) const
{
  return VPvarUint::Is( Equal )(ps);
}

VPvarBool VPvarUint::IsSymb( ==)(const Uint & t) const
{
  return VPvarUint::Is( Equal )(t);
}
VPvarBool VPvarUint::Is( Diff )(const VPvarUint& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Diff , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUint::Is( Diff )(const Uint & t) const
{
  VPvarBool r(Size(), NULL);
  Uint tmp = t;

  VBOOLWISE_BIN( Diff , Uint )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUint::IsSymb( != )(const VPvarUint& ps) const
{
  return VPvarUint::Is( Diff )(ps);
}

VPvarBool VPvarUint::IsSymb( !=)(const Uint & t) const
{
  return VPvarUint::Is( Diff )(t);
}
VPvarBool VPvarUint::Is( Inf )(const VPvarUint& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Inf , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUint::Is( Inf )(const Uint & t) const
{
  VPvarBool r(Size(), NULL);
  Uint tmp = t;

  VBOOLWISE_BIN( Inf , Uint )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUint::IsSymb( < )(const VPvarUint& ps) const
{
  return VPvarUint::Is( Inf )(ps);
}

VPvarBool VPvarUint::IsSymb( <)(const Uint & t) const
{
  return VPvarUint::Is( Inf )(t);
}
VPvarBool VPvarUint::Is( Sup )(const VPvarUint& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Sup , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUint::Is( Sup )(const Uint & t) const
{
  VPvarBool r(Size(), NULL);
  Uint tmp = t;

  VBOOLWISE_BIN( Sup , Uint )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUint::IsSymb( > )(const VPvarUint& ps) const
{
  return VPvarUint::Is( Sup )(ps);
}

VPvarBool VPvarUint::IsSymb( >)(const Uint & t) const
{
  return VPvarUint::Is( Sup )(t);
}
VPvarBool VPvarUint::Is( InfEqual )(const VPvarUint& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( InfEqual , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUint::Is( InfEqual )(const Uint & t) const
{
  VPvarBool r(Size(), NULL);
  Uint tmp = t;

  VBOOLWISE_BIN( InfEqual , Uint )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUint::IsSymb( <= )(const VPvarUint& ps) const
{
  return VPvarUint::Is( InfEqual )(ps);
}

VPvarBool VPvarUint::IsSymb( <=)(const Uint & t) const
{
  return VPvarUint::Is( InfEqual )(t);
}
VPvarBool VPvarUint::Is( SupEqual )(const VPvarUint& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( SupEqual , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUint::Is( SupEqual )(const Uint & t) const
{
  VPvarBool r(Size(), NULL);
  Uint tmp = t;

  VBOOLWISE_BIN( SupEqual , Uint )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUint::IsSymb( >= )(const VPvarUint& ps) const
{
  return VPvarUint::Is( SupEqual )(ps);
}

VPvarBool VPvarUint::IsSymb( >=)(const Uint & t) const
{
  return VPvarUint::Is( SupEqual )(t);
}

/* Binary operations */
VPvarUint& VPvarUint::operator=(const VPvarUint & ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Copy , Uint )(vpvBuffer, ps.getBuffer(), vnet, Size(), 0);

  return *this;
}

VPvarUint& VPvarUint::operator=(const Uint & t)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint tmp = t;

  VELMTWISE_BIN( Copy , Uint )(vpvBuffer, &tmp, vnet, Size(), ANET_EXTENDED);

  return *this;
}

VPvarUint& VPvarUint::EqualName( Max )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Max , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( Max )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Max , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::EqualName( Min )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Min , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( Min )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Min , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::EqualName( Or )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Or , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( Or )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Or , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::operator|=(const VPvarUint& p)
{
  return EqualName( Or )(p);
}

VPvarUint& VPvarUint::operator|=(const Uint & t)
{
  return EqualName( Or )(t);
}

VPvarUint VPvarUint::operator|(const VPvarUint& ps)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Or , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUint VPvarUint::operator|(const Uint & t)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint tmp = t;

  VELMTWISE_BIN( Or , Uint )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUint& VPvarUint::EqualName( And )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( And , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( And )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( And , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::operator&=(const VPvarUint& p)
{
  return EqualName( And )(p);
}

VPvarUint& VPvarUint::operator&=(const Uint & t)
{
  return EqualName( And )(t);
}

VPvarUint VPvarUint::operator&(const VPvarUint& ps)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( And , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUint VPvarUint::operator&(const Uint & t)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint tmp = t;

  VELMTWISE_BIN( And , Uint )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUint& VPvarUint::EqualName( Xor )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Xor , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( Xor )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Xor , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::operator^=(const VPvarUint& p)
{
  return EqualName( Xor )(p);
}

VPvarUint& VPvarUint::operator^=(const Uint & t)
{
  return EqualName( Xor )(t);
}

VPvarUint VPvarUint::operator^(const VPvarUint& ps)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Xor , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUint VPvarUint::operator^(const Uint & t)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint tmp = t;

  VELMTWISE_BIN( Xor , Uint )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUint& VPvarUint::EqualName( Plus )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Plus , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( Plus )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Plus , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::operator+=(const VPvarUint& p)
{
  return EqualName( Plus )(p);
}

VPvarUint& VPvarUint::operator+=(const Uint & t)
{
  return EqualName( Plus )(t);
}

VPvarUint VPvarUint::operator+(const VPvarUint& ps)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Plus , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUint VPvarUint::operator+(const Uint & t)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint tmp = t;

  VELMTWISE_BIN( Plus , Uint )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUint& VPvarUint::EqualName( Minus )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Minus , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( Minus )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Minus , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::operator-=(const VPvarUint& p)
{
  return EqualName( Minus )(p);
}

VPvarUint& VPvarUint::operator-=(const Uint & t)
{
  return EqualName( Minus )(t);
}

VPvarUint VPvarUint::operator-(const VPvarUint& ps)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Minus , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUint VPvarUint::operator-(const Uint & t)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint tmp = t;

  VELMTWISE_BIN( Minus , Uint )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUint& VPvarUint::EqualName( Mult )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mult , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( Mult )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Mult , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::operator*=(const VPvarUint& p)
{
  return EqualName( Mult )(p);
}

VPvarUint& VPvarUint::operator*=(const Uint & t)
{
  return EqualName( Mult )(t);
}

VPvarUint VPvarUint::operator*(const VPvarUint& ps)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mult , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUint VPvarUint::operator*(const Uint & t)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint tmp = t;

  VELMTWISE_BIN( Mult , Uint )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUint& VPvarUint::EqualName( Div )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Div , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( Div )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Div , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::operator/=(const VPvarUint& p)
{
  return EqualName( Div )(p);
}

VPvarUint& VPvarUint::operator/=(const Uint & t)
{
  return EqualName( Div )(t);
}

VPvarUint VPvarUint::operator/(const VPvarUint& ps)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Div , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUint VPvarUint::operator/(const Uint & t)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint tmp = t;

  VELMTWISE_BIN( Div , Uint )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUint& VPvarUint::EqualName( Shl )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shl , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( Shl )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Shl , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::operator<<=(const VPvarUint& p)
{
  return EqualName( Shl )(p);
}

VPvarUint& VPvarUint::operator<<=(const Uint & t)
{
  return EqualName( Shl )(t);
}

VPvarUint VPvarUint::operator<<(const VPvarUint& ps)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shl , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUint VPvarUint::operator<<(const Uint & t)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint tmp = t;

  VELMTWISE_BIN( Shl , Uint )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUint& VPvarUint::EqualName( Shr )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shr , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( Shr )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Shr , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::operator>>=(const VPvarUint& p)
{
  return EqualName( Shr )(p);
}

VPvarUint& VPvarUint::operator>>=(const Uint & t)
{
  return EqualName( Shr )(t);
}

VPvarUint VPvarUint::operator>>(const VPvarUint& ps)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shr , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUint VPvarUint::operator>>(const Uint & t)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint tmp = t;

  VELMTWISE_BIN( Shr , Uint )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUint& VPvarUint::EqualName( Mod )(const VPvarUint& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mod , Uint )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUint& VPvarUint::EqualName( Mod )(const Uint & t)
{
  Uint tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Mod , Uint )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUint& VPvarUint::operator%=(const VPvarUint& p)
{
  return EqualName( Mod )(p);
}

VPvarUint& VPvarUint::operator%=(const Uint & t)
{
  return EqualName( Mod )(t);
}

VPvarUint VPvarUint::operator%(const VPvarUint& ps)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mod , Uint )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUint VPvarUint::operator%(const Uint & t)
{
  VPvarUint r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Uint tmp = t;

  VELMTWISE_BIN( Mod , Uint )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}

/* Step Associations */
void VPvarUint::StepAssoc( Max )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( Max , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( Max )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( Max , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUint::StepAssoc( Max )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Max , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( Max )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Max , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUint::StepAssoc( Min )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( Min , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( Min )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( Min , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUint::StepAssoc( Min )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Min , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( Min )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Min , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUint::StepAssoc( Or )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( Or , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( Or )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( Or , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUint::StepAssoc( Or )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Or , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( Or )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Or , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUint::StepAssoc( And )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( And , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( And )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( And , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUint::StepAssoc( And )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( And , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( And )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( And , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUint::StepAssoc( Plus )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( Plus , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( Plus )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( Plus , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUint::StepAssoc( Plus )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Plus , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( Plus )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Plus , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUint::StepAssoc( Minus )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( Minus , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( Minus )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VSTEP_BIN( Minus , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUint::StepAssoc( Minus )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Minus , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUint::StepAssocEx( Minus )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Minus , Uint )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}


/* Direct Associations (r-ops & s-ops) */
void VPvarUint::DirectAssoc( Max )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Max , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUint::DirectAssoc( Max )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Max , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUint::DirectAssoc( Min )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Min , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUint::DirectAssoc( Min )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Min , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUint::DirectAssoc( Or )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Or , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUint::DirectAssoc( Or )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Or , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUint::DirectAssoc( And )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VDIRECT_ASSOC(And , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUint::DirectAssoc( And )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(And , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUint::DirectAssoc( Minc )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Minc , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUint::DirectAssoc( Minc )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Minc , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}


/* Associations (non-idempotent ops) */
void VPvarUint::Assoc( Max )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Max , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUint::Assoc( Max )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Max , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUint::Assoc( Or )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Or , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUint::Assoc( Or )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Or , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUint::Assoc( Plus )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Plus , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUint::Assoc( Plus )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Plus , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUint::Assoc( Mult )(VSubnet& s, const VPvarUint& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Mult , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUint::Assoc( Mult )(VSubnet& s, const VPvarUint& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Mult , Uint)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}


/* Extend primitive */
void VPvarUint::Extend(PvarUint& pvar, Vnet& vnet)
{
	VEXTEND( Uint )(vpvBuffer, pvar.getBuffer(), vnet.VirtualNet(), 0);
}
void VPvarUint::Extend(PvarUint& pvar)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	VEXTEND( Uint )(vpvBuffer, pvar.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

/* Reduction from a pvar */
void VPvarUint::VReduce( Max )(PvarUint & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Max , Uint )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUint::VReduce( Max )(PvarUint & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Max , Uint )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUint::VReduce( Min )(PvarUint & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Min , Uint )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUint::VReduce( Min )(PvarUint & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Min , Uint )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUint::VReduce( Or )(PvarUint & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Or , Uint )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUint::VReduce( Or )(PvarUint & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Or , Uint )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUint::VReduce( And )(PvarUint & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( And , Uint )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUint::VReduce( And )(PvarUint & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( And , Uint )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUint::VReduce( Xor )(PvarUint & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Xor , Uint )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUint::VReduce( Xor )(PvarUint & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Xor , Uint )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUint::VReduce( Plus )(PvarUint & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Plus , Uint )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUint::VReduce( Plus )(PvarUint & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Plus , Uint )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUint::VReduce( Mult )(PvarUint & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Mult , Uint )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUint::VReduce( Mult )(PvarUint & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Mult , Uint )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}

/* Link-with / Lop-offs instructions as Pvar friend functions */
void VLinkWith( Equal )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist, const Vnet& vnet)
{
    VLINK_WITH( Equal , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Equal )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Equal , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( Diff )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist, const Vnet& vnet)
{
    VLINK_WITH( Diff , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Diff )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Diff , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( Inf )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist, const Vnet& vnet)
{
    VLINK_WITH( Inf , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Inf )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Inf , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( Sup )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist, const Vnet& vnet)
{
    VLINK_WITH( Sup , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Sup )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Sup , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( InfEqual )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist, const Vnet& vnet)
{
    VLINK_WITH( InfEqual , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( InfEqual )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( InfEqual , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( SupEqual )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist, const Vnet& vnet)
{
    VLINK_WITH( SupEqual , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( SupEqual )(VSubnet& s, const VPvarUint& loc, const VPvarUint& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( SupEqual , Uint )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}


VPvarUbyte::VPvarUbyte()
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	vpvBuffer = new Ubyte[size = (Vnet::Implicit())->ComponentCount()];
}

VPvarUbyte::VPvarUbyte(const Ubyte & t)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	vpvBuffer = new Ubyte[size = (Vnet::Implicit())->ComponentCount()];
	*this = t;
}

VPvarUbyte::VPvarUbyte(const int s, const Ubyte *p)
{
	vpvBuffer = new Ubyte[size = s];
	if (p) memcpy(vpvBuffer, p, size * sizeof(Ubyte));
}

/* Global scan */
Ubyte VPvarUbyte::GlobalMax(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte r;

  VGLOBAL_BIN( Max , Ubyte )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Ubyte VPvarUbyte::GlobalMax(const Vnet& vnet, unsigned flag)
{
  Ubyte r;

  VGLOBAL_BIN( Max , Ubyte )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Ubyte VPvarUbyte::GlobalMin(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte r;

  VGLOBAL_BIN( Min , Ubyte )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Ubyte VPvarUbyte::GlobalMin(const Vnet& vnet, unsigned flag)
{
  Ubyte r;

  VGLOBAL_BIN( Min , Ubyte )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Ubyte VPvarUbyte::GlobalOr(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte r;

  VGLOBAL_BIN( Or , Ubyte )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Ubyte VPvarUbyte::GlobalOr(const Vnet& vnet, unsigned flag)
{
  Ubyte r;

  VGLOBAL_BIN( Or , Ubyte )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Ubyte VPvarUbyte::GlobalAnd(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte r;

  VGLOBAL_BIN( And , Ubyte )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Ubyte VPvarUbyte::GlobalAnd(const Vnet& vnet, unsigned flag)
{
  Ubyte r;

  VGLOBAL_BIN( And , Ubyte )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Ubyte VPvarUbyte::GlobalXor(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte r;

  VGLOBAL_BIN( Xor , Ubyte )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Ubyte VPvarUbyte::GlobalXor(const Vnet& vnet, unsigned flag)
{
  Ubyte r;

  VGLOBAL_BIN( Xor , Ubyte )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Ubyte VPvarUbyte::GlobalPlus(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte r;

  VGLOBAL_BIN( Plus , Ubyte )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Ubyte VPvarUbyte::GlobalPlus(const Vnet& vnet, unsigned flag)
{
  Ubyte r;

  VGLOBAL_BIN( Plus , Ubyte )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Ubyte VPvarUbyte::GlobalMult(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte r;

  VGLOBAL_BIN( Mult , Ubyte )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Ubyte VPvarUbyte::GlobalMult(const Vnet& vnet, unsigned flag)
{
  Ubyte r;

  VGLOBAL_BIN( Mult , Ubyte )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}

/* Self operation (self-address etc.) */
void VPvarUbyte::Self(Complement)(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  VELMTWISE_SELF( Complement , Ubyte )(vpvBuffer, vpvBuffer, Size(), vnet, flag);
}

void VPvarUbyte::Self(Complement)(const Vnet& vnet, unsigned flag)
{
  VELMTWISE_SELF( Complement , Ubyte )(vpvBuffer, vpvBuffer, Size(), vnet.VirtualNet(), flag);
}
void VPvarUbyte::Self(Address)(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  VELMTWISE_SELF( Address , Ubyte )(vpvBuffer, vpvBuffer, Size(), vnet, flag);
}

void VPvarUbyte::Self(Address)(const Vnet& vnet, unsigned flag)
{
  VELMTWISE_SELF( Address , Ubyte )(vpvBuffer, vpvBuffer, Size(), vnet.VirtualNet(), flag);
}
void VPvarUbyte::Self(Rand)(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  VELMTWISE_SELF( Rand , Ubyte )(vpvBuffer, vpvBuffer, Size(), vnet, flag);
}

void VPvarUbyte::Self(Rand)(const Vnet& vnet, unsigned flag)
{
  VELMTWISE_SELF( Rand , Ubyte )(vpvBuffer, vpvBuffer, Size(), vnet.VirtualNet(), flag);
}

/* BOOLEAN INSTRUCTION */
VPvarBool VPvarUbyte::Is( Equal )(const VPvarUbyte& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Equal , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUbyte::Is( Equal )(const Ubyte & t) const
{
  VPvarBool r(Size(), NULL);
  Ubyte tmp = t;

  VBOOLWISE_BIN( Equal , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUbyte::IsSymb( == )(const VPvarUbyte& ps) const
{
  return VPvarUbyte::Is( Equal )(ps);
}

VPvarBool VPvarUbyte::IsSymb( ==)(const Ubyte & t) const
{
  return VPvarUbyte::Is( Equal )(t);
}
VPvarBool VPvarUbyte::Is( Diff )(const VPvarUbyte& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Diff , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUbyte::Is( Diff )(const Ubyte & t) const
{
  VPvarBool r(Size(), NULL);
  Ubyte tmp = t;

  VBOOLWISE_BIN( Diff , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUbyte::IsSymb( != )(const VPvarUbyte& ps) const
{
  return VPvarUbyte::Is( Diff )(ps);
}

VPvarBool VPvarUbyte::IsSymb( !=)(const Ubyte & t) const
{
  return VPvarUbyte::Is( Diff )(t);
}
VPvarBool VPvarUbyte::Is( Inf )(const VPvarUbyte& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Inf , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUbyte::Is( Inf )(const Ubyte & t) const
{
  VPvarBool r(Size(), NULL);
  Ubyte tmp = t;

  VBOOLWISE_BIN( Inf , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUbyte::IsSymb( < )(const VPvarUbyte& ps) const
{
  return VPvarUbyte::Is( Inf )(ps);
}

VPvarBool VPvarUbyte::IsSymb( <)(const Ubyte & t) const
{
  return VPvarUbyte::Is( Inf )(t);
}
VPvarBool VPvarUbyte::Is( Sup )(const VPvarUbyte& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Sup , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUbyte::Is( Sup )(const Ubyte & t) const
{
  VPvarBool r(Size(), NULL);
  Ubyte tmp = t;

  VBOOLWISE_BIN( Sup , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUbyte::IsSymb( > )(const VPvarUbyte& ps) const
{
  return VPvarUbyte::Is( Sup )(ps);
}

VPvarBool VPvarUbyte::IsSymb( >)(const Ubyte & t) const
{
  return VPvarUbyte::Is( Sup )(t);
}
VPvarBool VPvarUbyte::Is( InfEqual )(const VPvarUbyte& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( InfEqual , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUbyte::Is( InfEqual )(const Ubyte & t) const
{
  VPvarBool r(Size(), NULL);
  Ubyte tmp = t;

  VBOOLWISE_BIN( InfEqual , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUbyte::IsSymb( <= )(const VPvarUbyte& ps) const
{
  return VPvarUbyte::Is( InfEqual )(ps);
}

VPvarBool VPvarUbyte::IsSymb( <=)(const Ubyte & t) const
{
  return VPvarUbyte::Is( InfEqual )(t);
}
VPvarBool VPvarUbyte::Is( SupEqual )(const VPvarUbyte& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( SupEqual , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarUbyte::Is( SupEqual )(const Ubyte & t) const
{
  VPvarBool r(Size(), NULL);
  Ubyte tmp = t;

  VBOOLWISE_BIN( SupEqual , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarUbyte::IsSymb( >= )(const VPvarUbyte& ps) const
{
  return VPvarUbyte::Is( SupEqual )(ps);
}

VPvarBool VPvarUbyte::IsSymb( >=)(const Ubyte & t) const
{
  return VPvarUbyte::Is( SupEqual )(t);
}

/* Binary operations */
VPvarUbyte& VPvarUbyte::operator=(const VPvarUbyte & ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Copy , Ubyte )(vpvBuffer, ps.getBuffer(), vnet, Size(), 0);

  return *this;
}

VPvarUbyte& VPvarUbyte::operator=(const Ubyte & t)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte tmp = t;

  VELMTWISE_BIN( Copy , Ubyte )(vpvBuffer, &tmp, vnet, Size(), ANET_EXTENDED);

  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Max )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Max , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Max )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Max , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::EqualName( Min )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Min , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Min )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Min , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::EqualName( Or )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Or , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Or )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Or , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::operator|=(const VPvarUbyte& p)
{
  return EqualName( Or )(p);
}

VPvarUbyte& VPvarUbyte::operator|=(const Ubyte & t)
{
  return EqualName( Or )(t);
}

VPvarUbyte VPvarUbyte::operator|(const VPvarUbyte& ps)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Or , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUbyte VPvarUbyte::operator|(const Ubyte & t)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte tmp = t;

  VELMTWISE_BIN( Or , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUbyte& VPvarUbyte::EqualName( And )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( And , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( And )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( And , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::operator&=(const VPvarUbyte& p)
{
  return EqualName( And )(p);
}

VPvarUbyte& VPvarUbyte::operator&=(const Ubyte & t)
{
  return EqualName( And )(t);
}

VPvarUbyte VPvarUbyte::operator&(const VPvarUbyte& ps)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( And , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUbyte VPvarUbyte::operator&(const Ubyte & t)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte tmp = t;

  VELMTWISE_BIN( And , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUbyte& VPvarUbyte::EqualName( Xor )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Xor , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Xor )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Xor , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::operator^=(const VPvarUbyte& p)
{
  return EqualName( Xor )(p);
}

VPvarUbyte& VPvarUbyte::operator^=(const Ubyte & t)
{
  return EqualName( Xor )(t);
}

VPvarUbyte VPvarUbyte::operator^(const VPvarUbyte& ps)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Xor , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUbyte VPvarUbyte::operator^(const Ubyte & t)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte tmp = t;

  VELMTWISE_BIN( Xor , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUbyte& VPvarUbyte::EqualName( Plus )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Plus , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Plus )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Plus , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::operator+=(const VPvarUbyte& p)
{
  return EqualName( Plus )(p);
}

VPvarUbyte& VPvarUbyte::operator+=(const Ubyte & t)
{
  return EqualName( Plus )(t);
}

VPvarUbyte VPvarUbyte::operator+(const VPvarUbyte& ps)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Plus , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUbyte VPvarUbyte::operator+(const Ubyte & t)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte tmp = t;

  VELMTWISE_BIN( Plus , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUbyte& VPvarUbyte::EqualName( Minus )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Minus , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Minus )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Minus , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::operator-=(const VPvarUbyte& p)
{
  return EqualName( Minus )(p);
}

VPvarUbyte& VPvarUbyte::operator-=(const Ubyte & t)
{
  return EqualName( Minus )(t);
}

VPvarUbyte VPvarUbyte::operator-(const VPvarUbyte& ps)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Minus , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUbyte VPvarUbyte::operator-(const Ubyte & t)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte tmp = t;

  VELMTWISE_BIN( Minus , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUbyte& VPvarUbyte::EqualName( Mult )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mult , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Mult )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Mult , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::operator*=(const VPvarUbyte& p)
{
  return EqualName( Mult )(p);
}

VPvarUbyte& VPvarUbyte::operator*=(const Ubyte & t)
{
  return EqualName( Mult )(t);
}

VPvarUbyte VPvarUbyte::operator*(const VPvarUbyte& ps)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mult , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUbyte VPvarUbyte::operator*(const Ubyte & t)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte tmp = t;

  VELMTWISE_BIN( Mult , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUbyte& VPvarUbyte::EqualName( Div )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Div , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Div )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Div , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::operator/=(const VPvarUbyte& p)
{
  return EqualName( Div )(p);
}

VPvarUbyte& VPvarUbyte::operator/=(const Ubyte & t)
{
  return EqualName( Div )(t);
}

VPvarUbyte VPvarUbyte::operator/(const VPvarUbyte& ps)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Div , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUbyte VPvarUbyte::operator/(const Ubyte & t)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte tmp = t;

  VELMTWISE_BIN( Div , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUbyte& VPvarUbyte::EqualName( Shl )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shl , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Shl )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Shl , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::operator<<=(const VPvarUbyte& p)
{
  return EqualName( Shl )(p);
}

VPvarUbyte& VPvarUbyte::operator<<=(const Ubyte & t)
{
  return EqualName( Shl )(t);
}

VPvarUbyte VPvarUbyte::operator<<(const VPvarUbyte& ps)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shl , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUbyte VPvarUbyte::operator<<(const Ubyte & t)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte tmp = t;

  VELMTWISE_BIN( Shl , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUbyte& VPvarUbyte::EqualName( Shr )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shr , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Shr )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Shr , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::operator>>=(const VPvarUbyte& p)
{
  return EqualName( Shr )(p);
}

VPvarUbyte& VPvarUbyte::operator>>=(const Ubyte & t)
{
  return EqualName( Shr )(t);
}

VPvarUbyte VPvarUbyte::operator>>(const VPvarUbyte& ps)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shr , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUbyte VPvarUbyte::operator>>(const Ubyte & t)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte tmp = t;

  VELMTWISE_BIN( Shr , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarUbyte& VPvarUbyte::EqualName( Mod )(const VPvarUbyte& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mod , Ubyte )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarUbyte& VPvarUbyte::EqualName( Mod )(const Ubyte & t)
{
  Ubyte tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Mod , Ubyte )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarUbyte& VPvarUbyte::operator%=(const VPvarUbyte& p)
{
  return EqualName( Mod )(p);
}

VPvarUbyte& VPvarUbyte::operator%=(const Ubyte & t)
{
  return EqualName( Mod )(t);
}

VPvarUbyte VPvarUbyte::operator%(const VPvarUbyte& ps)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mod , Ubyte )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarUbyte VPvarUbyte::operator%(const Ubyte & t)
{
  VPvarUbyte r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Ubyte tmp = t;

  VELMTWISE_BIN( Mod , Ubyte )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}

/* Step Associations */
void VPvarUbyte::StepAssoc( Max )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( Max , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( Max )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( Max , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUbyte::StepAssoc( Max )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Max , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( Max )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Max , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUbyte::StepAssoc( Min )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( Min , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( Min )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( Min , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUbyte::StepAssoc( Min )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Min , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( Min )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Min , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUbyte::StepAssoc( Or )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( Or , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( Or )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( Or , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUbyte::StepAssoc( Or )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Or , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( Or )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Or , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUbyte::StepAssoc( And )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( And , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( And )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( And , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUbyte::StepAssoc( And )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( And , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( And )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( And , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUbyte::StepAssoc( Plus )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( Plus , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( Plus )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( Plus , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUbyte::StepAssoc( Plus )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Plus , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( Plus )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Plus , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUbyte::StepAssoc( Minus )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( Minus , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( Minus )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VSTEP_BIN( Minus , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarUbyte::StepAssoc( Minus )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Minus , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUbyte::StepAssocEx( Minus )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Minus , Ubyte )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}


/* Direct Associations (r-ops & s-ops) */
void VPvarUbyte::DirectAssoc( Max )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Max , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUbyte::DirectAssoc( Max )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Max , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUbyte::DirectAssoc( Min )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Min , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUbyte::DirectAssoc( Min )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Min , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUbyte::DirectAssoc( Or )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Or , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUbyte::DirectAssoc( Or )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Or , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUbyte::DirectAssoc( And )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VDIRECT_ASSOC(And , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUbyte::DirectAssoc( And )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(And , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarUbyte::DirectAssoc( Minc )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Minc , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarUbyte::DirectAssoc( Minc )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Minc , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}


/* Associations (non-idempotent ops) */
void VPvarUbyte::Assoc( Max )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Max , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUbyte::Assoc( Max )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Max , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUbyte::Assoc( Or )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Or , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUbyte::Assoc( Or )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Or , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUbyte::Assoc( Plus )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Plus , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUbyte::Assoc( Plus )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Plus , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUbyte::Assoc( Mult )(VSubnet& s, const VPvarUbyte& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Mult , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarUbyte::Assoc( Mult )(VSubnet& s, const VPvarUbyte& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Mult , Ubyte)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}


/* Extend primitive */
void VPvarUbyte::Extend(PvarUbyte& pvar, Vnet& vnet)
{
	VEXTEND( Ubyte )(vpvBuffer, pvar.getBuffer(), vnet.VirtualNet(), 0);
}
void VPvarUbyte::Extend(PvarUbyte& pvar)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	VEXTEND( Ubyte )(vpvBuffer, pvar.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

/* Reduction from a pvar */
void VPvarUbyte::VReduce( Max )(PvarUbyte & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Max , Ubyte )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUbyte::VReduce( Max )(PvarUbyte & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Max , Ubyte )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUbyte::VReduce( Min )(PvarUbyte & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Min , Ubyte )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUbyte::VReduce( Min )(PvarUbyte & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Min , Ubyte )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUbyte::VReduce( Or )(PvarUbyte & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Or , Ubyte )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUbyte::VReduce( Or )(PvarUbyte & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Or , Ubyte )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUbyte::VReduce( And )(PvarUbyte & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( And , Ubyte )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUbyte::VReduce( And )(PvarUbyte & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( And , Ubyte )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUbyte::VReduce( Xor )(PvarUbyte & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Xor , Ubyte )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUbyte::VReduce( Xor )(PvarUbyte & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Xor , Ubyte )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUbyte::VReduce( Plus )(PvarUbyte & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Plus , Ubyte )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUbyte::VReduce( Plus )(PvarUbyte & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Plus , Ubyte )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarUbyte::VReduce( Mult )(PvarUbyte & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Mult , Ubyte )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarUbyte::VReduce( Mult )(PvarUbyte & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Mult , Ubyte )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}

/* Link-with / Lop-offs instructions as Pvar friend functions */
void VLinkWith( Equal )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist, const Vnet& vnet)
{
    VLINK_WITH( Equal , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Equal )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Equal , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( Diff )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist, const Vnet& vnet)
{
    VLINK_WITH( Diff , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Diff )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Diff , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( Inf )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist, const Vnet& vnet)
{
    VLINK_WITH( Inf , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Inf )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Inf , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( Sup )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist, const Vnet& vnet)
{
    VLINK_WITH( Sup , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Sup )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Sup , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( InfEqual )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist, const Vnet& vnet)
{
    VLINK_WITH( InfEqual , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( InfEqual )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( InfEqual , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( SupEqual )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist, const Vnet& vnet)
{
    VLINK_WITH( SupEqual , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( SupEqual )(VSubnet& s, const VPvarUbyte& loc, const VPvarUbyte& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( SupEqual , Ubyte )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}


VPvarInt::VPvarInt()
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	vpvBuffer = new Int[size = (Vnet::Implicit())->ComponentCount()];
}

VPvarInt::VPvarInt(const Int & t)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	vpvBuffer = new Int[size = (Vnet::Implicit())->ComponentCount()];
	*this = t;
}

VPvarInt::VPvarInt(const int s, const Int *p)
{
	vpvBuffer = new Int[size = s];
	if (p) memcpy(vpvBuffer, p, size * sizeof(Int));
}

/* Global scan */
Int VPvarInt::GlobalMax(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int r;

  VGLOBAL_BIN( Max , Int )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Int VPvarInt::GlobalMax(const Vnet& vnet, unsigned flag)
{
  Int r;

  VGLOBAL_BIN( Max , Int )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Int VPvarInt::GlobalMin(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int r;

  VGLOBAL_BIN( Min , Int )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Int VPvarInt::GlobalMin(const Vnet& vnet, unsigned flag)
{
  Int r;

  VGLOBAL_BIN( Min , Int )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Int VPvarInt::GlobalOr(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int r;

  VGLOBAL_BIN( Or , Int )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Int VPvarInt::GlobalOr(const Vnet& vnet, unsigned flag)
{
  Int r;

  VGLOBAL_BIN( Or , Int )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Int VPvarInt::GlobalAnd(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int r;

  VGLOBAL_BIN( And , Int )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Int VPvarInt::GlobalAnd(const Vnet& vnet, unsigned flag)
{
  Int r;

  VGLOBAL_BIN( And , Int )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Int VPvarInt::GlobalXor(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int r;

  VGLOBAL_BIN( Xor , Int )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Int VPvarInt::GlobalXor(const Vnet& vnet, unsigned flag)
{
  Int r;

  VGLOBAL_BIN( Xor , Int )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Int VPvarInt::GlobalPlus(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int r;

  VGLOBAL_BIN( Plus , Int )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Int VPvarInt::GlobalPlus(const Vnet& vnet, unsigned flag)
{
  Int r;

  VGLOBAL_BIN( Plus , Int )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
Int VPvarInt::GlobalMult(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int r;

  VGLOBAL_BIN( Mult , Int )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

Int VPvarInt::GlobalMult(const Vnet& vnet, unsigned flag)
{
  Int r;

  VGLOBAL_BIN( Mult , Int )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}

/* Self operation (self-address etc.) */
void VPvarInt::Self(Complement)(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  VELMTWISE_SELF( Complement , Int )(vpvBuffer, vpvBuffer, Size(), vnet, flag);
}

void VPvarInt::Self(Complement)(const Vnet& vnet, unsigned flag)
{
  VELMTWISE_SELF( Complement , Int )(vpvBuffer, vpvBuffer, Size(), vnet.VirtualNet(), flag);
}
void VPvarInt::Self(Address)(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  VELMTWISE_SELF( Address , Int )(vpvBuffer, vpvBuffer, Size(), vnet, flag);
}

void VPvarInt::Self(Address)(const Vnet& vnet, unsigned flag)
{
  VELMTWISE_SELF( Address , Int )(vpvBuffer, vpvBuffer, Size(), vnet.VirtualNet(), flag);
}
void VPvarInt::Self(Abs)(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  VELMTWISE_SELF( Abs , Int )(vpvBuffer, vpvBuffer, Size(), vnet, flag);
}

void VPvarInt::Self(Abs)(const Vnet& vnet, unsigned flag)
{
  VELMTWISE_SELF( Abs , Int )(vpvBuffer, vpvBuffer, Size(), vnet.VirtualNet(), flag);
}
void VPvarInt::Self(Rand)(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  VELMTWISE_SELF( Rand , Int )(vpvBuffer, vpvBuffer, Size(), vnet, flag);
}

void VPvarInt::Self(Rand)(const Vnet& vnet, unsigned flag)
{
  VELMTWISE_SELF( Rand , Int )(vpvBuffer, vpvBuffer, Size(), vnet.VirtualNet(), flag);
}

/* BOOLEAN INSTRUCTION */
VPvarBool VPvarInt::Is( Equal )(const VPvarInt& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Equal , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarInt::Is( Equal )(const Int & t) const
{
  VPvarBool r(Size(), NULL);
  Int tmp = t;

  VBOOLWISE_BIN( Equal , Int )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarInt::IsSymb( == )(const VPvarInt& ps) const
{
  return VPvarInt::Is( Equal )(ps);
}

VPvarBool VPvarInt::IsSymb( ==)(const Int & t) const
{
  return VPvarInt::Is( Equal )(t);
}
VPvarBool VPvarInt::Is( Diff )(const VPvarInt& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Diff , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarInt::Is( Diff )(const Int & t) const
{
  VPvarBool r(Size(), NULL);
  Int tmp = t;

  VBOOLWISE_BIN( Diff , Int )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarInt::IsSymb( != )(const VPvarInt& ps) const
{
  return VPvarInt::Is( Diff )(ps);
}

VPvarBool VPvarInt::IsSymb( !=)(const Int & t) const
{
  return VPvarInt::Is( Diff )(t);
}
VPvarBool VPvarInt::Is( Inf )(const VPvarInt& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Inf , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarInt::Is( Inf )(const Int & t) const
{
  VPvarBool r(Size(), NULL);
  Int tmp = t;

  VBOOLWISE_BIN( Inf , Int )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarInt::IsSymb( < )(const VPvarInt& ps) const
{
  return VPvarInt::Is( Inf )(ps);
}

VPvarBool VPvarInt::IsSymb( <)(const Int & t) const
{
  return VPvarInt::Is( Inf )(t);
}
VPvarBool VPvarInt::Is( Sup )(const VPvarInt& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( Sup , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarInt::Is( Sup )(const Int & t) const
{
  VPvarBool r(Size(), NULL);
  Int tmp = t;

  VBOOLWISE_BIN( Sup , Int )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarInt::IsSymb( > )(const VPvarInt& ps) const
{
  return VPvarInt::Is( Sup )(ps);
}

VPvarBool VPvarInt::IsSymb( >)(const Int & t) const
{
  return VPvarInt::Is( Sup )(t);
}
VPvarBool VPvarInt::Is( InfEqual )(const VPvarInt& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( InfEqual , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarInt::Is( InfEqual )(const Int & t) const
{
  VPvarBool r(Size(), NULL);
  Int tmp = t;

  VBOOLWISE_BIN( InfEqual , Int )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarInt::IsSymb( <= )(const VPvarInt& ps) const
{
  return VPvarInt::Is( InfEqual )(ps);
}

VPvarBool VPvarInt::IsSymb( <=)(const Int & t) const
{
  return VPvarInt::Is( InfEqual )(t);
}
VPvarBool VPvarInt::Is( SupEqual )(const VPvarInt& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( SupEqual , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvarInt::Is( SupEqual )(const Int & t) const
{
  VPvarBool r(Size(), NULL);
  Int tmp = t;

  VBOOLWISE_BIN( SupEqual , Int )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
VPvarBool VPvarInt::IsSymb( >= )(const VPvarInt& ps) const
{
  return VPvarInt::Is( SupEqual )(ps);
}

VPvarBool VPvarInt::IsSymb( >=)(const Int & t) const
{
  return VPvarInt::Is( SupEqual )(t);
}

/* Binary operations */
VPvarInt& VPvarInt::operator=(const VPvarInt & ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Copy , Int )(vpvBuffer, ps.getBuffer(), vnet, Size(), 0);

  return *this;
}

VPvarInt& VPvarInt::operator=(const Int & t)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int tmp = t;

  VELMTWISE_BIN( Copy , Int )(vpvBuffer, &tmp, vnet, Size(), ANET_EXTENDED);

  return *this;
}

VPvarInt& VPvarInt::EqualName( Max )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Max , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( Max )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Max , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::EqualName( Min )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Min , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( Min )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Min , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::EqualName( Or )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Or , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( Or )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Or , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::operator|=(const VPvarInt& p)
{
  return EqualName( Or )(p);
}

VPvarInt& VPvarInt::operator|=(const Int & t)
{
  return EqualName( Or )(t);
}

VPvarInt VPvarInt::operator|(const VPvarInt& ps)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Or , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarInt VPvarInt::operator|(const Int & t)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int tmp = t;

  VELMTWISE_BIN( Or , Int )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarInt& VPvarInt::EqualName( And )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( And , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( And )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( And , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::operator&=(const VPvarInt& p)
{
  return EqualName( And )(p);
}

VPvarInt& VPvarInt::operator&=(const Int & t)
{
  return EqualName( And )(t);
}

VPvarInt VPvarInt::operator&(const VPvarInt& ps)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( And , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarInt VPvarInt::operator&(const Int & t)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int tmp = t;

  VELMTWISE_BIN( And , Int )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarInt& VPvarInt::EqualName( Xor )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Xor , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( Xor )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Xor , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::operator^=(const VPvarInt& p)
{
  return EqualName( Xor )(p);
}

VPvarInt& VPvarInt::operator^=(const Int & t)
{
  return EqualName( Xor )(t);
}

VPvarInt VPvarInt::operator^(const VPvarInt& ps)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Xor , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarInt VPvarInt::operator^(const Int & t)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int tmp = t;

  VELMTWISE_BIN( Xor , Int )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarInt& VPvarInt::EqualName( Plus )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Plus , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( Plus )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Plus , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::operator+=(const VPvarInt& p)
{
  return EqualName( Plus )(p);
}

VPvarInt& VPvarInt::operator+=(const Int & t)
{
  return EqualName( Plus )(t);
}

VPvarInt VPvarInt::operator+(const VPvarInt& ps)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Plus , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarInt VPvarInt::operator+(const Int & t)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int tmp = t;

  VELMTWISE_BIN( Plus , Int )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarInt& VPvarInt::EqualName( Minus )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Minus , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( Minus )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Minus , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::operator-=(const VPvarInt& p)
{
  return EqualName( Minus )(p);
}

VPvarInt& VPvarInt::operator-=(const Int & t)
{
  return EqualName( Minus )(t);
}

VPvarInt VPvarInt::operator-(const VPvarInt& ps)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Minus , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarInt VPvarInt::operator-(const Int & t)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int tmp = t;

  VELMTWISE_BIN( Minus , Int )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarInt& VPvarInt::EqualName( Mult )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mult , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( Mult )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Mult , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::operator*=(const VPvarInt& p)
{
  return EqualName( Mult )(p);
}

VPvarInt& VPvarInt::operator*=(const Int & t)
{
  return EqualName( Mult )(t);
}

VPvarInt VPvarInt::operator*(const VPvarInt& ps)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mult , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarInt VPvarInt::operator*(const Int & t)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int tmp = t;

  VELMTWISE_BIN( Mult , Int )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarInt& VPvarInt::EqualName( Div )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Div , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( Div )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Div , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::operator/=(const VPvarInt& p)
{
  return EqualName( Div )(p);
}

VPvarInt& VPvarInt::operator/=(const Int & t)
{
  return EqualName( Div )(t);
}

VPvarInt VPvarInt::operator/(const VPvarInt& ps)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Div , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarInt VPvarInt::operator/(const Int & t)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int tmp = t;

  VELMTWISE_BIN( Div , Int )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarInt& VPvarInt::EqualName( Shl )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shl , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( Shl )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Shl , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::operator<<=(const VPvarInt& p)
{
  return EqualName( Shl )(p);
}

VPvarInt& VPvarInt::operator<<=(const Int & t)
{
  return EqualName( Shl )(t);
}

VPvarInt VPvarInt::operator<<(const VPvarInt& ps)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shl , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarInt VPvarInt::operator<<(const Int & t)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int tmp = t;

  VELMTWISE_BIN( Shl , Int )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarInt& VPvarInt::EqualName( Shr )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shr , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( Shr )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Shr , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::operator>>=(const VPvarInt& p)
{
  return EqualName( Shr )(p);
}

VPvarInt& VPvarInt::operator>>=(const Int & t)
{
  return EqualName( Shr )(t);
}

VPvarInt VPvarInt::operator>>(const VPvarInt& ps)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Shr , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarInt VPvarInt::operator>>(const Int & t)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int tmp = t;

  VELMTWISE_BIN( Shr , Int )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
VPvarInt& VPvarInt::EqualName( Mod )(const VPvarInt& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mod , Int )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvarInt& VPvarInt::EqualName( Mod )(const Int & t)
{
  Int tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( Mod , Int )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
VPvarInt& VPvarInt::operator%=(const VPvarInt& p)
{
  return EqualName( Mod )(p);
}

VPvarInt& VPvarInt::operator%=(const Int & t)
{
  return EqualName( Mod )(t);
}

VPvarInt VPvarInt::operator%(const VPvarInt& ps)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Mod , Int )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvarInt VPvarInt::operator%(const Int & t)
{
  VPvarInt r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  Int tmp = t;

  VELMTWISE_BIN( Mod , Int )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}

/* Step Associations */
void VPvarInt::StepAssoc( Max )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( Max , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( Max )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( Max , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarInt::StepAssoc( Max )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Max , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( Max )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Max , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarInt::StepAssoc( Min )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( Min , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( Min )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( Min , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarInt::StepAssoc( Min )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Min , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( Min )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Min , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarInt::StepAssoc( Or )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( Or , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( Or )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( Or , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarInt::StepAssoc( Or )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Or , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( Or )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Or , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarInt::StepAssoc( And )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( And , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( And )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( And , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarInt::StepAssoc( And )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( And , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( And )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( And , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarInt::StepAssoc( Plus )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( Plus , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( Plus )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( Plus , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarInt::StepAssoc( Plus )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Plus , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( Plus )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Plus , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarInt::StepAssoc( Minus )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( Minus , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( Minus )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VSTEP_BIN( Minus , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvarInt::StepAssoc( Minus )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Minus , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarInt::StepAssocEx( Minus )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( Minus , Int )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}


/* Direct Associations (r-ops & s-ops) */
void VPvarInt::DirectAssoc( Max )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Max , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarInt::DirectAssoc( Max )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Max , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarInt::DirectAssoc( Min )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Min , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarInt::DirectAssoc( Min )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Min , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarInt::DirectAssoc( Or )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Or , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarInt::DirectAssoc( Or )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Or , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarInt::DirectAssoc( And )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VDIRECT_ASSOC(And , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarInt::DirectAssoc( And )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(And , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvarInt::DirectAssoc( Minc )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
  VDIRECT_ASSOC(Minc , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvarInt::DirectAssoc( Minc )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC(Minc , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}


/* Associations (non-idempotent ops) */
void VPvarInt::Assoc( Max )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Max , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarInt::Assoc( Max )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Max , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarInt::Assoc( Or )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Or , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarInt::Assoc( Or )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Or , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarInt::Assoc( Plus )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Plus , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarInt::Assoc( Plus )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Plus , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarInt::Assoc( Mult )(VSubnet& s, const VPvarInt& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Mult , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvarInt::Assoc( Mult )(VSubnet& s, const VPvarInt& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC(Mult , Int)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}


/* Extend primitive */
void VPvarInt::Extend(PvarInt& pvar, Vnet& vnet)
{
	VEXTEND( Int )(vpvBuffer, pvar.getBuffer(), vnet.VirtualNet(), 0);
}
void VPvarInt::Extend(PvarInt& pvar)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	VEXTEND( Int )(vpvBuffer, pvar.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

/* Reduction from a pvar */
void VPvarInt::VReduce( Max )(PvarInt & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Max , Int )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarInt::VReduce( Max )(PvarInt & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Max , Int )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarInt::VReduce( Min )(PvarInt & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Min , Int )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarInt::VReduce( Min )(PvarInt & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Min , Int )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarInt::VReduce( Or )(PvarInt & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Or , Int )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarInt::VReduce( Or )(PvarInt & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Or , Int )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarInt::VReduce( And )(PvarInt & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( And , Int )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarInt::VReduce( And )(PvarInt & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( And , Int )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarInt::VReduce( Xor )(PvarInt & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Xor , Int )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarInt::VReduce( Xor )(PvarInt & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Xor , Int )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarInt::VReduce( Plus )(PvarInt & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Plus , Int )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarInt::VReduce( Plus )(PvarInt & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Plus , Int )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
void VPvarInt::VReduce( Mult )(PvarInt & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( Mult , Int )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvarInt::VReduce( Mult )(PvarInt & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( Mult , Int )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}

/* Link-with / Lop-offs instructions as Pvar friend functions */
void VLinkWith( Equal )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist, const Vnet& vnet)
{
    VLINK_WITH( Equal , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Equal )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Equal , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( Diff )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist, const Vnet& vnet)
{
    VLINK_WITH( Diff , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Diff )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Diff , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( Inf )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist, const Vnet& vnet)
{
    VLINK_WITH( Inf , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Inf )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Inf , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( Sup )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist, const Vnet& vnet)
{
    VLINK_WITH( Sup , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( Sup )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( Sup , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( InfEqual )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist, const Vnet& vnet)
{
    VLINK_WITH( InfEqual , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( InfEqual )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( InfEqual , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
void VLinkWith( SupEqual )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist, const Vnet& vnet)
{
    VLINK_WITH( SupEqual , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( SupEqual )(VSubnet& s, const VPvarInt& loc, const VPvarInt& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( SupEqual , Int )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

