/*
 *  vpvar.cc
 *  Anet
 *
 *  Created by Nicolas Sicard on Mon Jul 21 2003.
 *  Copyright (c) 2003 IEF. All rights reserved.
 *
 */

/*
    Perl generated file
    VPvar object implementation -- encapsulates Anet Core C functions
*/

:do $datafile ;

#if ANET_SYS == Darwin
#include <limits.h>
#else
#include <values.h>
#endif

#include <ostream.h>

#include "vpvar.h"
#include "vpvarbool.h"
#include "vsubnet.h"
#include "operator.h"
/* Use Anet Core C functions */
extern "C" {
#include "vlocal.h"
};

:foreach $TYPE (@ANET_TYPES) {

VPvar$TYPE::VPvar$TYPE()
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	vpvBuffer = new $TYPE[size = (Vnet::Implicit())->ComponentCount()];
}

VPvar$TYPE::VPvar$TYPE(const $TYPE & t)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	vpvBuffer = new $TYPE[size = (Vnet::Implicit())->ComponentCount()];
	*this = t;
}

VPvar$TYPE::VPvar$TYPE(const int s, const $TYPE *p)
{
	vpvBuffer = new $TYPE[size = s];
	if (p) memcpy(vpvBuffer, p, size * sizeof($TYPE));
}

/* Global scan */
:foreach $OP (@{$REDUCE_FOR_TYPE{$TYPE}}) {
$TYPE VPvar$TYPE::Global$OP(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  $TYPE r;

  VGLOBAL_BIN( $OP , $TYPE )(&r, vpvBuffer, Size(), vnet, flag);
  return r;
}

$TYPE VPvar$TYPE::Global$OP(const Vnet& vnet, unsigned flag)
{
  $TYPE r;

  VGLOBAL_BIN( $OP , $TYPE )(&r, vpvBuffer, Size(), vnet.VirtualNet(), flag);
  return r;
}
:}

/* Self operation (self-address etc.) */
:foreach $OP (@{$SELF_FOR_TYPE{$TYPE}}) {
void VPvar$TYPE::Self($OP)(unsigned flag)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  VELMTWISE_SELF( $OP , $TYPE )(vpvBuffer, vpvBuffer, Size(), vnet, flag);
}

void VPvar$TYPE::Self($OP)(const Vnet& vnet, unsigned flag)
{
  VELMTWISE_SELF( $OP , $TYPE )(vpvBuffer, vpvBuffer, Size(), vnet.VirtualNet(), flag);
}
:}

/* BOOLEAN INSTRUCTION */
:foreach $OP (@{$BOOLWISE_FOR_TYPE{$TYPE}}) {
VPvarBool VPvar$TYPE::Is( $OP )(const VPvar$TYPE& ps) const
{
  VPvarBool r(Size(), NULL);

  VBOOLWISE_BIN( $OP , $TYPE )(r.getBuffer(), vpvBuffer, ps.getBuffer(), Size(), 0);
  return r;
}

VPvarBool VPvar$TYPE::Is( $OP )(const $TYPE & t) const
{
  VPvarBool r(Size(), NULL);
  $TYPE tmp = t;

  VBOOLWISE_BIN( $OP , $TYPE )(r.getBuffer(), vpvBuffer, &tmp, Size(), ANET_EXTENDED);
  return r;
}

/* Boolean instructions with symbol */
:if ((grep /^$OP$/ , keys %SYMBOL) != 0) {
VPvarBool VPvar$TYPE::IsSymb( $SYMBOL{$OP} )(const VPvar$TYPE& ps) const
{
  return VPvar$TYPE::Is( $OP )(ps);
}

VPvarBool VPvar$TYPE::IsSymb( $SYMBOL{$OP})(const $TYPE & t) const
{
  return VPvar$TYPE::Is( $OP )(t);
}
:}
:}

/* Binary operations */
VPvar$TYPE& VPvar$TYPE::operator=(const VPvar$TYPE & ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( Copy , $TYPE )(vpvBuffer, ps.getBuffer(), vnet, Size(), 0);

  return *this;
}

VPvar$TYPE& VPvar$TYPE::operator=(const $TYPE & t)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  $TYPE tmp = t;

  VELMTWISE_BIN( Copy , $TYPE )(vpvBuffer, &tmp, vnet, Size(), ANET_EXTENDED);

  return *this;
}

:foreach $OP (@{$ELMTWISE_FOR_TYPE{$TYPE}}) {
VPvar$TYPE& VPvar$TYPE::EqualName( $OP )(const VPvar$TYPE& ps)
{
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( $OP , $TYPE )(vpvBuffer, vpvBuffer, ps.getBuffer(), vnet , Size(), 0);
  return *this;
}

VPvar$TYPE& VPvar$TYPE::EqualName( $OP )(const $TYPE & t)
{
  $TYPE tmp = t;
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  
  VELMTWISE_BIN( $OP , $TYPE )(vpvBuffer, vpvBuffer, &tmp, vnet, size, ANET_EXTENDED);
  return *this;
}

/* Binary operations with symbol */
:if ((grep /^$OP$/ , keys %SYMBOL) != 0) {
VPvar$TYPE& VPvar$TYPE::operator$SYMBOL{$OP}=(const VPvar$TYPE& p)
{
  return EqualName( $OP )(p);
}

VPvar$TYPE& VPvar$TYPE::operator$SYMBOL{$OP}=(const $TYPE & t)
{
  return EqualName( $OP )(t);
}

VPvar$TYPE VPvar$TYPE::operator$SYMBOL{$OP}(const VPvar$TYPE& ps)
{
  VPvar$TYPE r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;

  VELMTWISE_BIN( $OP , $TYPE )(r.getBuffer(), vpvBuffer, ps.getBuffer(), vnet, Size(), 0);
  return r;
}

VPvar$TYPE VPvar$TYPE::operator$SYMBOL{$OP}(const $TYPE & t)
{
  VPvar$TYPE r(Size(), NULL);
  ANET_VNET *vnet = (Vnet::Implicit())? Vnet::Implicit()->VirtualNet() : NULL;
  $TYPE tmp = t;

  VELMTWISE_BIN( $OP , $TYPE )(r.getBuffer(), vpvBuffer, &tmp, vnet, r.Size(), ANET_EXTENDED);
  return r;
}
:}
:}

/* Step Associations */
:foreach $OP (@{$STEP_FOR_TYPE{$TYPE}}) {
void VPvar$TYPE::StepAssoc( $OP )(VSubnet& s, const VPvar$TYPE& ps, const Vnet& v)
{
  VSTEP_BIN( $OP , $TYPE )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvar$TYPE::StepAssocEx( $OP )(VSubnet& s, const VPvar$TYPE& ps, const Vnet& v)
{
  VSTEP_BIN( $OP , $TYPE )(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), ANET_EXCLUSIVE);
}

void VPvar$TYPE::StepAssoc( $OP )(VSubnet& s, const VPvar$TYPE& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( $OP , $TYPE )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

void VPvar$TYPE::StepAssocEx( $OP )(VSubnet& s, const VPvar$TYPE& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VSTEP_BIN( $OP , $TYPE )(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), ANET_EXCLUSIVE);
}

:}

/* Direct Associations (r-ops & s-ops) */
:foreach $OP (@{$DIRECT_FOR_TYPE{$TYPE}}) {
void VPvar$TYPE::DirectAssoc( $OP )(VSubnet& s, const VPvar$TYPE& ps, const Vnet& v)
{
  VDIRECT_ASSOC($OP , $TYPE)(vpvBuffer, ps.getBuffer(), s.getBuffer(), v.VirtualNet(), 0);
}

void VPvar$TYPE::DirectAssoc( $OP )(VSubnet& s, const VPvar$TYPE& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
  VDIRECT_ASSOC($OP , $TYPE)(vpvBuffer, ps.getBuffer(), s.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

:}

/* Associations (non-idempotent ops) */
:foreach $OP (@{$ASSOC_FOR_TYPE{$TYPE}}) {
void VPvar$TYPE::Assoc( $OP )(VSubnet& s, const VPvar$TYPE& ps, const Vnet& v)
{
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(v.VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC($OP , $TYPE)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

void VPvar$TYPE::Assoc( $OP )(VSubnet& s, const VPvar$TYPE& ps)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	ANET_VRNET *vrnet;
	
	vrnet = (s.vrnet != NULL)? s.vrnet : newVRnet(Vnet::Implicit()->VirtualNet());
	
	if (s.vrnet == NULL) vrnet_reduce(vrnet, s.getBuffer());
	VASSOC($OP , $TYPE)(vpvBuffer, ps.getBuffer(), s.getBuffer(), vrnet, 0);
	if (s.vrnet == NULL) s.vrnet = vrnet;
}

:}

/* Extend primitive */
void VPvar$TYPE::Extend(Pvar$TYPE& pvar, Vnet& vnet)
{
	VEXTEND( $TYPE )(vpvBuffer, pvar.getBuffer(), vnet.VirtualNet(), 0);
}
void VPvar$TYPE::Extend(Pvar$TYPE& pvar)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	VEXTEND( $TYPE )(vpvBuffer, pvar.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}

/* Reduction from a pvar */
:foreach $OP (@{$REDUCE_FOR_TYPE{$TYPE}}) {
void VPvar$TYPE::VReduce( $OP )(Pvar$TYPE & p, Vnet& v, unsigned flag)
{
    VREDUCE_BIN( $OP , $TYPE )(vpvBuffer, p.getBuffer(), v.VirtualNet(), flag);
}
void VPvar$TYPE::VReduce( $OP )(Pvar$TYPE & p, unsigned flag)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VREDUCE_BIN( $OP , $TYPE )(vpvBuffer, p.getBuffer(), Vnet::Implicit()->VirtualNet(), flag);
}
:}

/* Link-with / Lop-offs instructions as Pvar friend functions */
:foreach $OP (@{$LWBINARY_FOR_TYPE{$TYPE}}) {
void VLinkWith( $OP )(VSubnet& s, const VPvar$TYPE& loc, const VPvar$TYPE& dist, const Vnet& vnet)
{
    VLINK_WITH( $OP , $TYPE )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), vnet.VirtualNet(), 0);
}
void VLinkWith( $OP )(VSubnet& s, const VPvar$TYPE& loc, const VPvar$TYPE& dist)
{
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
    VLINK_WITH( $OP , $TYPE )(s.getBuffer(), loc.getBuffer(), dist.getBuffer(), Vnet::Implicit()->VirtualNet(), 0);
}
:}

:}
