/*
 *  vpvarbool.cc
 *  Anet
 *
 *  Created by Nicolas on Tue Apr 20 2004.
 *  Copyright (c) 2004 IEF. All rights reserved.
 *
 */

#include "vpvarbool.h"
/* Use Anet Core C functions */
extern "C" {
#include "vlocal.h"
};

VPvarBool::VPvarBool() : VPvarUbyte() {}
VPvarBool::VPvarBool(const Vnet& v) : VPvarUbyte(v) {}
VPvarBool::VPvarBool(const VPvarBool& pvb) : VPvarUbyte(pvb) {}

VPvarBool::VPvarBool(const int b) : VPvarUbyte()
{
	Ubyte m = (b != 0)? (Ubyte)0xff : (Ubyte)0x00;
	*this = m;
}

VPvarBool::VPvarBool(const int b, const Vnet& v) : VPvarUbyte(v)
{
	Ubyte m = (b != 0)? (Ubyte)0xff : (Ubyte)0x00;
	*this = m;
}

// special constructor for low-level size-based memory copy
VPvarBool::VPvarBool(const int s, const Ubyte *p) : VPvarUbyte(s, p) { }

//VPvarBool::~VPvarBool() {}

void VPvarBool::Not()
{
    Ubyte m = 0xff;
    VELMTWISE_BIN( Xor , Ubyte )(vpvBuffer, vpvBuffer, &m, NULL, Size(), ANET_EXTENDED);
}

VPvarBool& VPvarBool::operator=(const VPvarBool& pb)
{
	memcpy(vpvBuffer,pb.vpvBuffer,Size()*sizeof(Ubyte));
	return *this;
}

VPvarBool VPvarBool::operator==(const VPvarBool& pb) const
{
	VPvarBool r(Size(), NULL);
	for (unsigned i = 0; i < Size(); i++)
		r.vpvBuffer[i] = ~(vpvBuffer[i] ^ pb.vpvBuffer[i]);
	return r;
}

VPvarBool VPvarBool::operator!=(const VPvarBool& pb) const
{
    VPvarBool r(Size(), NULL);
    VELMTWISE_BIN( Xor , Ubyte )(r.getBuffer(), vpvBuffer, pb.getBuffer(), NULL, Size(), 0);
	/*for (unsigned i = 0; i < Size(); i++)
		r.pvBuffer[i] = pvBuffer[i] ^ pb.pvBuffer[i];*/
	return r;
}

VPvarBool VPvarBool::operator&&(const VPvarBool& pb) const
{
    VPvarBool r(Size(), NULL);
    VELMTWISE_BIN( And , Ubyte )(r.getBuffer(), vpvBuffer, pb.getBuffer(), NULL, Size(), 0);
    /*for (unsigned i = 0; i < Size(); i++)
        r.pvBuffer[i] = pvBuffer[i] & pb.pvBuffer[i];*/
	return r;
}

VPvarBool VPvarBool::operator||(const VPvarBool& pb) const
{
    VPvarBool r(Size(), NULL);
    VELMTWISE_BIN( Or , Ubyte )(r.getBuffer(), vpvBuffer, pb.getBuffer(), NULL, Size(), 0);
    /*for (unsigned i = 0; i < Size(); i++)
        r.pvBuffer[i] = pvBuffer[i] | pb.pvBuffer[i];*/
	return r;
}

VPvarBool operator!(const VPvarBool& pb)
{
	VPvarBool r(pb.Size(), NULL);
	for (unsigned i = 0; i < pb.Size(); i++)
		(r.getBuffer())[i] = ~((pb.getBuffer())[i]);
	return r;
}
