/*
 *  vpvarbool.h
 *  Anet
 *
 *  Created by Nicolas on Tue Apr 20 2004.
 *  Copyright (c) 2004 IEF. All rights reserved.
 *
 */

#ifndef _VPVARBOOL_H_
#define _VPVARBOOL_H_

#include "vpvar.h"
#include "pvarbool.h"

/***************************************************************/
/*							 VSubnet                           */
/***************************************************************/

class VPvarBool : protected VPvarUbyte {
public:
	VPvarBool();
    VPvarBool(const int b);
    VPvarBool(const Vnet& v);
    VPvarBool(const int b, const Vnet& v);
    VPvarBool(const VPvarBool& pvb);
	VPvarBool(const int s, const Ubyte *);

	/* self-apply not operator */
	void Not();
	
	/* return if nth node is true or false*/
	int operator()(unsigned n) const {
		return vpvBuffer[n] != (Ubyte)0x00;
	}
	
	/* Set the nth node to true */
	void Set(unsigned n){
		vpvBuffer[n] = (Ubyte)0xff;
	}
	/* Set the nth node to false */
	void Unset(unsigned n){
		vpvBuffer[n] = (Ubyte)0x00;
	}
	
	VPvarBool& operator=(const VPvarBool&);
	
	VPvarBool operator==(const VPvarBool&) const;
	VPvarBool operator!=(const VPvarBool&) const;
	VPvarBool operator&&(const VPvarBool&) const;
	VPvarBool operator||(const VPvarBool&) const;

	Ubyte *getBuffer() const { return vpvBuffer; }
	unsigned int Size() const { return size; }
};

#endif /* _VSUBNET_H_ */
