/*
 *  vsubnet.cc
 *  Anet
 *
 *  Created by Nicolas on Mon Jul 21 2003.
 *  Copyright (c) 2003 IEF. All rights reserved.
 *
 * $Id: vsubnet.cc,v 1.1.1.1 2003/09/09 14:41:04 nico Exp $
 * $Log: vsubnet.cc,v $
 * Revision 1.1.1.1  2003/09/09 14:41:04  nico
 * Version 0.9
 *
 * Revision 1.4  2003/07/25 16:20:42  nico
 * Retour dans le repertoire Source/Object
 *
 * Revision 1.1  2003/07/25 13:09:58  nico
 * Deplacement des fichier dans l'arborescence Virtual => bibliotheque a part
 *
 * Revision 1.3  2003/07/23 12:39:37  nico
 * Version fonctionnelle
 *
 *
 */

#include "vsubnet.h"
/* Use Anet Core C functions */
extern "C" {
#include "vlocal.h"
};

VSubnet::VSubnet() {
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	size = (Vnet::Implicit())->LinkCount() / (sizeof(Ubyte)*8) + 1;
	vpvBuffer = new Ubyte[size];
	vrnet = NULL;
}

VSubnet::VSubnet(Ubyte m) {
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	size = (Vnet::Implicit())->LinkCount() / (sizeof(Ubyte)*8) + 1;
	vpvBuffer = new Ubyte[size]; 
	for (unsigned i = 0; i < size; i++) vpvBuffer[i] = m;
	vrnet = NULL;
}

void VSubnet::Symmetrize(Vnet& v) {
	VSYMMETRIZE(vpvBuffer, v.VirtualNet(), 0);
	FlushRnet();
}

void VSubnet::Symmetrize() {
	if (Vnet::Implicit() == NULL) {
		fprintf(stderr, "VNET> Fatal Error : no implicit virtual net declared. Program terminated\n");
		exit(1);
	}
	VSYMMETRIZE(vpvBuffer, Vnet::Implicit()->VirtualNet(), 0);
	FlushRnet();
}