/*
 *  vsubnet.h
 *  Anet
 *
 *  Created by Nicolas on Mon Jul 21 2003.
 *  Copyright (c) 2003 IEF. All rights reserved.
 *
 * $Id: vsubnet.h,v 1.1.1.1 2003/09/09 14:41:04 nico Exp $
 * $Log: vsubnet.h,v $
 * Revision 1.1.1.1  2003/09/09 14:41:04  nico
 * Version 0.9
 *
 * Revision 1.5  2003/07/25 16:20:42  nico
 * Retour dans le repertoire Source/Object
 *
 * Revision 1.1  2003/07/25 13:09:58  nico
 * Deplacement des fichiers dans l'arborescence Virtual => bibliotheque a part
 *
 * Revision 1.4  2003/07/25 12:03:50  nico
 * Ajout d'un retour a la ligne en fin de fichier (gcc3.2)
 *
 * Revision 1.3  2003/07/23 12:39:37  nico
 * Version fonctionnelle
 *
 *
 */

#ifndef _VSUBNET_H_
#define _VSUBNET_H_

#include "vpvar.h"

#define VPvarMask VPvarUbyte

/***************************************************************/
/*							 VSubnet                           */
/***************************************************************/

class VSubnet : public VPvarMask {
public:
	ANET_VRNET  *vrnet;
public:
	VSubnet();
    VSubnet(Ubyte m);
    VSubnet(Vnet& v) { vpvBuffer = new Ubyte[size = (v.LinkCount()/8 + 1)]; vrnet = NULL; }
    VSubnet(Ubyte m, Vnet& v) {
        vpvBuffer = new Ubyte[size = (v.LinkCount()/8 + 1)];
        for (unsigned i = 0; i < size; i++) vpvBuffer[i] = m;
		vrnet = NULL;
    }
	~VSubnet() { if (vrnet!= NULL) vrnet_free(vrnet); vrnet = NULL; }

	void Symmetrize(Vnet& v);
	void Symmetrize();
	
	void FlushRnet() { if (vrnet != NULL) vrnet_free(vrnet); vrnet = NULL; }
};

#endif /* _VSUBNET_H_ */
