/*
 *  wpvar.h
 *  Anet
 *
 *  Created by Nicolas on Sat Apr 17 2004.
 *  Copyright (c) 2004 IEF. All rights reserved.
 *
 */

/*
 Perl generated file
 Pvar object interface
 */


#ifndef _PVAR_H_
#define _PVAR_H_

#include <string.h>

/* Use Anet Core C functions */
extern "C" {
#include "step.h"
#include "elmtwise.h"
#include "boolwise.h"
#include "direct.h"
#include "assoc.h"
#include "reduce.h"
#include "local.h"
#include "files.h"
}

#include "anetcore.h"


/***************************************************************/
/*							  WPvar                            */
/***************************************************************/

class WPvarUint : public Anet{
protected:
		// internal buffer
		Uint *pvBuffer;
public:
		// constructors and destructor
		WPvarUint() { pvBuffer = new Uint[Size()*ANET_MASK_SIZE]; }
		WPvarUint(const WUint & t) { pvBuffer = new Uint[ANET_MASK_SIZE*Size()]; *this = t; }
		WPvarUint(const WPvarUint& p) {
			pvBuffer = new Uint[Size()*ANET_MASK_SIZE];
			memcpy(pvBuffer, p.pvBuffer, Size()*ANET_MASK_SIZE*sizeof(Uint));
		}
/*
		PvarUint(const char *filename) {
			pvBuffer = new Uint[Size()];
			READ_PVARFILE( Uint )(pvBuffer, core, filename);
		}
 */
		~WPvarUint() { delete [] pvBuffer; }
		
		/* Reading/writing from (ascii pgm) file */
/*
		void ReadFile(const char *filename) {
			READ_PVARFILE( Uint )( pvBuffer, core, filename);
		}
		void WriteFile(const char *filename, const char type[4]) {
			WRITE_PVARFILE( Uint )(pvBuffer, core, filename, type);
		}

		PvarUint & operator=(const PvarUint &);
		PvarUint & operator=(const Uint &);
*/

		// low-level data acces
		// WARNING : non secured (but faster) method, please test index range!
		void Set(const int i, Uint *val) {
			memcpy(pvBuffer[ANET_MASK_SIZE * i], val, ANET_MASK_SIZE * sizeof(Uint));
		}
		void Get(const int i, Uint *val) {
			memcpy(val, pvBuffer[ANET_MASK_SIZE * i], ANET_MASK_SIZE * sizeof(Uint));
		}
	
		// data-parallel fonction apply
		PvarUint& Apply(Uint (*)( Uint ));
		Uint *getBuffer() const { return pvBuffer; }
	};
	
class WPvarUbyte : public Anet{
protected:
		// internal buffer
		Ubyte *pvBuffer;
public:
		// constructors and destructor
		WPvarUbyte() { pvBuffer = new Ubyte[Size()*ANET_MASK_SIZE]; }
		WPvarUbyte(const WUbyte & t) { pvBuffer = new Ubyte[ANET_MASK_SIZE*Size()]; *this = t; }
		WPvarUbyte(const WPvarUbyte& p) {
			pvBuffer = new Ubyte[Size()*ANET_MASK_SIZE];
			memcpy(pvBuffer, p.pvBuffer, Size()*ANET_MASK_SIZE*sizeof(Ubyte));
		}
/*
		PvarUbyte(const char *filename) {
			pvBuffer = new Ubyte[Size()];
			READ_PVARFILE( Ubyte )(pvBuffer, core, filename);
		}
 */
		~WPvarUbyte() { delete [] pvBuffer; }
		
		/* Reading/writing from (ascii pgm) file */
/*
		void ReadFile(const char *filename) {
			READ_PVARFILE( Ubyte )( pvBuffer, core, filename);
		}
		void WriteFile(const char *filename, const char type[4]) {
			WRITE_PVARFILE( Ubyte )(pvBuffer, core, filename, type);
		}

		PvarUbyte & operator=(const PvarUbyte &);
		PvarUbyte & operator=(const Ubyte &);
*/

		// low-level data acces
		// WARNING : non secured (but faster) method, please test index range!
		void Set(const int i, Ubyte *val) {
			memcpy(pvBuffer[ANET_MASK_SIZE * i], val, ANET_MASK_SIZE * sizeof(Ubyte));
		}
		void Get(const int i, Ubyte *val) {
			memcpy(val, pvBuffer[ANET_MASK_SIZE * i], ANET_MASK_SIZE * sizeof(Ubyte));
		}
	
		// data-parallel fonction apply
		PvarUbyte& Apply(Ubyte (*)( Ubyte ));
		Ubyte *getBuffer() const { return pvBuffer; }
	};
	
class WPvarInt : public Anet{
protected:
		// internal buffer
		Int *pvBuffer;
public:
		// constructors and destructor
		WPvarInt() { pvBuffer = new Int[Size()*ANET_MASK_SIZE]; }
		WPvarInt(const WInt & t) { pvBuffer = new Int[ANET_MASK_SIZE*Size()]; *this = t; }
		WPvarInt(const WPvarInt& p) {
			pvBuffer = new Int[Size()*ANET_MASK_SIZE];
			memcpy(pvBuffer, p.pvBuffer, Size()*ANET_MASK_SIZE*sizeof(Int));
		}
/*
		PvarInt(const char *filename) {
			pvBuffer = new Int[Size()];
			READ_PVARFILE( Int )(pvBuffer, core, filename);
		}
 */
		~WPvarInt() { delete [] pvBuffer; }
		
		/* Reading/writing from (ascii pgm) file */
/*
		void ReadFile(const char *filename) {
			READ_PVARFILE( Int )( pvBuffer, core, filename);
		}
		void WriteFile(const char *filename, const char type[4]) {
			WRITE_PVARFILE( Int )(pvBuffer, core, filename, type);
		}

		PvarInt & operator=(const PvarInt &);
		PvarInt & operator=(const Int &);
*/

		// low-level data acces
		// WARNING : non secured (but faster) method, please test index range!
		void Set(const int i, Int *val) {
			memcpy(pvBuffer[ANET_MASK_SIZE * i], val, ANET_MASK_SIZE * sizeof(Int));
		}
		void Get(const int i, Int *val) {
			memcpy(val, pvBuffer[ANET_MASK_SIZE * i], ANET_MASK_SIZE * sizeof(Int));
		}
	
		// data-parallel fonction apply
		PvarInt& Apply(Int (*)( Int ));
		Int *getBuffer() const { return pvBuffer; }
	};
	

#endif

